SystemOrganization addCategory: #'SWE-IssueTracker'!

SUComponent subclass: #ITComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponent methodsFor: 'rendering' stamp: 'mt 12/30/2007 18:04'!
renderButtonOn: html with: text action: anUpdate
	html anchor
		class: 'button';
		onClick: anUpdate;
		with: [ html span
			class: 'button';
			with: [html text: text]
		]! !

!ITComponent methodsFor: 'updating' stamp: 'mt 12/30/2007 10:29'!
updateRoot: anHtmlRoot
	"Appends a unique style to all used components."
	
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet
		url: ITFileLibrary / #mainCss.! !

ITComponent subclass: #ITComponentAddComment
	instanceVariableNames: 'comment currentIssue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentAddComment class methodsFor: 'instance creation' stamp: 'mt 1/4/2008 23:17'!
newWith: anID
	| newInstance |
	newInstance := self new.
	newInstance currentIssue: (newInstance session issueManager getIssueWithID: anID).
	^newInstance.! !

!ITComponentAddComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 19:11'!
comment
	^ comment! !

!ITComponentAddComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 19:11'!
comment: anObject
	comment := anObject! !

!ITComponentAddComment methodsFor: 'accessing' stamp: 'mt 1/4/2008 23:16'!
currentIssue
	^ currentIssue! !

!ITComponentAddComment methodsFor: 'accessing' stamp: 'mt 1/4/2008 23:16'!
currentIssue: anObject
	currentIssue := anObject! !

!ITComponentAddComment methodsFor: 'rendering' stamp: 'mt 1/5/2008 11:26'!
renderContentOn: html

	html div: [
		html anchor
			onClick: (html effect id: 'new_comment_form'; perform: #toggleBlind);
			with: 'Add Comment' tr.
				
		html form
			id: 'new_comment_form';
			style: 'display: none;';
			with: [
				html textArea on: #comment of: self.
				html break.
				html submitButton
					callback: [ 
						self session issueManager
							addComment: self comment
							atID: self currentIssue id
							by: self session user
					];
					text: 'Add Comment' tr.
			]
	]! !

ITComponent subclass: #ITComponentAddIssue
	instanceVariableNames: 'title newTags newTag initialComment newTagValue TMPavailTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentAddIssue methodsFor: 'as yet unclassified' stamp: 'afk 1/6/2008 00:02'!
deleteEntries
	"Delete data in inputfields after clicking cancel or submit"

	self initialComment: nil.
	self title: nil.
	self newTagValue: nil.
	self newTag: nil.
	self newTags: Dictionary new.
	! !

!ITComponentAddIssue methodsFor: 'as yet unclassified' stamp: 'afk 1/6/2008 00:02'!
deleteTagEntries
	self newTag: nil.
	self newTagValue: nil.! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
initialComment
	^ initialComment! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
initialComment: anObject
	initialComment := anObject! !

!ITComponentAddIssue methodsFor: 'as yet unclassified' stamp: 'afk 1/6/2008 00:59'!
initialize
	
	super initialize.
	self newTags: (Dictionary new).
	self tMPavailTags: #('Color' 'Priority' 'Language').! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 1/5/2008 20:32'!
newTag
	^ newTag! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 1/5/2008 20:32'!
newTag: anObject
	newTag := anObject! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 1/5/2008 20:32'!
newTagValue
	^ newTagValue! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 1/5/2008 20:32'!
newTagValue: anObject
	newTagValue := anObject! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 1/5/2008 21:37'!
newTags
	^ newTags! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 1/5/2008 21:37'!
newTags: anObject
	newTags := anObject! !

!ITComponentAddIssue methodsFor: 'rendering' stamp: 'afk 1/6/2008 01:02'!
renderContentOn: html
					
	html div
		class: 'content';
		with: [
			html heading: 'Add Issue' tr level: 1.	
			html form: 
				[
				html text: 'Title' tr.
					html break.
				html textInput on: #title of: self.
					html break.
					html break.
				self renderCurrentTagsOn: html.
					html break.
				self renderTagFormOn: html.
					html break. 
					html break.
				html text: 'Description' tr.
					html break.
				html textArea on: #initialComment of: self.
					html break.
			
				html submitButton 
					callback: [
						self submit.		
						self deleteEntries.	
						self answer: true. 
					];
					value: 'add Issue' tr.
				html cancelButton
					callback: [
						self deleteEntries.
						self answer: false];
					value: 'cancel' tr.
		]]! !

!ITComponentAddIssue methodsFor: 'as yet unclassified' stamp: 'afk 1/6/2008 01:03'!
renderCreateNewTagOn: html
	"Renders the possibility to add new tags while creating a new Issue"
				
	html div
		id: 'issue';
		with: [
			html form
				id: 'new_tag_form';
				style: 'display: none;';
				with: 	[
					html text: 'New Tag' tr.
						html break.
					html text: 'Name' tr.
						html space.
					html textInput 
						script: html formElement focus;
						on: #newTag of: self.
						html space.
					html text: 'Value' tr.
						html space.
					html textInput on: #newTagValue of: self.
						html space.
		
					html submitButton 
						callback: [	
							self newTag ifNotNil: [self newTags at: self newTag put: self newTagValue].
							self deleteTagEntries.
							self answer: true. 
								];
						value: 'add this Tag' tr.
					html break.
						].
			].
	
	"If the user has to choose a task instead of defining new ones himself "
	
"	html heading
		id: 'select_heading';
		level: 2;
		with: [ html text: 'Tag: ' tr, self newTag asString ].

	html form
		id: 'user_drop_down';
		with: [
			html select
				list: (self tMPavailTags);
				selected: self newTag;
				callback: [ :value | self newTag: value ];
				onChange: (html updater
					id: 'select_heading';
					triggerForm: 'user_drop_down';
					callback: [:r | r text: 'Tag: ' tr, self newTag asString ]).
				]."! !

!ITComponentAddIssue methodsFor: 'as yet unclassified' stamp: 'afk 1/6/2008 00:22'!
renderCurrentTagsOn: html
	"Shows the tags that the user provided to be added. User has the abillity to remove them before saving"

	"html heading: 'Your entered tags' tr level: 3."
	html fieldSet
		legend: 'Current tags:' tr;
		style: '	font-weight: normal;
				color: black;';
		with: [ 	self newTags associationsDo: [:assoc | 
				html div
					id: (assoc key);
					with: [
						html strong: 'Tag: ' tr.
						html text: (assoc key). 
						html space. 
						html strong: 'Content: ' tr.
						html text: (assoc value). 
						html space.
																							
						html anchor
							onClick: (html updater
								id: (assoc key);
								callback: [:render | self newTags removeKey: (assoc key).]);
							with: 'Delete'.
												
						html break.]
											]
				].! !

!ITComponentAddIssue methodsFor: 'as yet unclassified' stamp: 'afk 1/6/2008 01:20'!
renderTagFormOn: html
	"Renders anchor for the form to add a new tag"

	html div
		id: 'tag_adding';
		with: [].	
	
	html anchor
		onClick: (html updater
			id: 'tag_adding';
			callback: [ :render | self renderCreateNewTagOn: render]);
		accessKey: $f;
		with: 'Write another Tag (Press Ctrl-F)' tr.! !

!ITComponentAddIssue methodsFor: 'as yet unclassified' stamp: 'afk 1/5/2008 22:08'!
submit
	"Submits the data an creates a new issue with an initial comment."
	
	|issue comment|
	[issue := self session issueManager addIssueWithTitle: self title]
		on: ITUnauthorizedError 
		do: [self inform: 'You are not authorized to add an issue!!' tr. ^nil].
	
	self newTags associationsDo: [:assoc | issue setDetailWith: (assoc key) to: (assoc value) ].
	
	comment := ITIssueComment with: self initialComment by: self session user.
	
	[self session issueManager addComment: comment atID: issue id]
		on: ITUnauthorizedError 
		do: [self inform: 'You are not authorized to add a comment to an issue!!' tr. ^nil].
! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 1/6/2008 00:47'!
tMPavailTags
	^ TMPavailTags! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 1/6/2008 00:47'!
tMPavailTags: anObject
	TMPavailTags := anObject! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
title
	^ title! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
title: anObject
	title := anObject! !

ITComponent subclass: #ITComponentAdmin
	instanceVariableNames: 'tabs selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentAdmin methodsFor: 'rendering' stamp: 'afk 1/5/2008 01:05'!
children
	^Array with: self selected.! !

!ITComponentAdmin methodsFor: 'initialization' stamp: 'mt 1/5/2008 19:40'!
initialize
	super initialize.
	self tabs: ((OrderedCollection new)
				add: 'User -> Roles' tr -> ITComponentAdminUsers new;
				add: 'Roles -> Privileges' tr -> ITComponentAdminRoles new;
				yourself).
	self selected: self tabs first value! !

!ITComponentAdmin methodsFor: 'rendering' stamp: 'mt 1/5/2008 19:44'!
renderChildrenOn: html
	html div
		class: 'content_with_menu';
		with: [
			html render: self selected.	
		]! !

!ITComponentAdmin methodsFor: 'rendering' stamp: 'mt 12/30/2007 21:47'!
renderContentOn: html
	html div
		with: [
			self renderSideMenuOn: html.
			self renderChildrenOn: html.
		]! !

!ITComponentAdmin methodsFor: 'rendering' stamp: 'mt 1/5/2008 19:47'!
renderSideMenuOn: html
	html div
		id: 'tab_menu';
		with: [
			html unorderedList "sections"
				with: [
					html listItem
						with: [
							html text: 'User Control'.
							html unorderedList
								with: [
									self tabs do: [:tab |
										html listItem 									
											class: (self selected = tab value ifTrue: ['active']);
											with: [
												html anchor
													callback: [ self selected: tab value ];
													with: tab key
											]
									]
								]
						].
					html listItem with: [ html text: 'Custom Details'].
					html listItem with: [ html text: 'stuff'].
				]
		]! !

!ITComponentAdmin methodsFor: 'accessing' stamp: 'afk 1/5/2008 01:04'!
selected
	^ selected! !

!ITComponentAdmin methodsFor: 'accessing' stamp: 'afk 1/5/2008 01:04'!
selected: anObject
	^ selected := anObject! !

!ITComponentAdmin methodsFor: 'accessing' stamp: 'afk 1/5/2008 01:04'!
tabs
	^ tabs! !

!ITComponentAdmin methodsFor: 'accessing' stamp: 'afk 1/5/2008 01:04'!
tabs: anObject
	tabs := anObject! !

ITComponent subclass: #ITComponentAdminRoles
	instanceVariableNames: 'attachedPrivileges availablePrivileges selectedRole newRolename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentAdminRoles methodsFor: 'private' stamp: 'mt 1/5/2008 22:56'!
addRole
	| newRole |
	newRole := ITRole new.
	newRole rolename: self newRolename.
	
	[self session securityManager addRole: newRole.]
		on: ITUnauthorizedError
		do: [self lightbox: (self inform: 'You are not authorized to add a role!!' tr)].
		
	self selectedRole: newRole.! !

!ITComponentAdminRoles methodsFor: 'private' stamp: 'mt 12/29/2007 16:07'!
applyChanges
	|session|
	session := ITGlorpSession getInstance.
	session inUnitOfWorkDo: [
		session register: selectedRole.
		selectedRole privileges: self attachedPrivileges asSet.
		]! !

!ITComponentAdminRoles methodsFor: 'accessing' stamp: 'mt 12/29/2007 15:12'!
attachedPrivileges
	^ attachedPrivileges! !

!ITComponentAdminRoles methodsFor: 'accessing' stamp: 'mt 12/29/2007 15:12'!
attachedPrivileges: anObject
	attachedPrivileges := anObject! !

!ITComponentAdminRoles methodsFor: 'accessing' stamp: 'mt 12/29/2007 15:12'!
availablePrivileges
	^ availablePrivileges! !

!ITComponentAdminRoles methodsFor: 'accessing' stamp: 'mt 12/29/2007 15:12'!
availablePrivileges: anObject
	availablePrivileges := anObject! !

!ITComponentAdminRoles methodsFor: 'private' stamp: 'mt 1/5/2008 23:41'!
deleteRole

	self flag: #TODO. "Users do have the role."

	[self session securityManager deleteRoleWithID: self selectedRole id]
		on: ITUnauthorizedError
		do: [self lightbox: (self inform: 'You are not authorized to delete a role!!' tr)].
		
	self selectedRole: (ITGlorpSession getInstance readOneOf: ITRole).

	self updatePrivileges.! !

!ITComponentAdminRoles methodsFor: 'initialization' stamp: 'mt 1/5/2008 22:17'!
initialize
	super initialize.
	
	self newRolename: 'New Role' tr.
	
	selectedRole := ITGlorpSession getInstance readOneOf: ITRole.
	self updatePrivileges.! !

!ITComponentAdminRoles methodsFor: 'accessing' stamp: 'mt 1/5/2008 22:17'!
newRolename
	^ newRolename! !

!ITComponentAdminRoles methodsFor: 'accessing' stamp: 'mt 1/5/2008 22:17'!
newRolename: anObject
	newRolename := anObject! !

!ITComponentAdminRoles methodsFor: 'rendering' stamp: 'mt 1/5/2008 23:23'!
renderApplyChangesButtonOn: html
	html div
		class: 'button';
		style: 'float: right; margin: 10px 5px;';
		with: [
			html image url: ITFileLibrary / #acceptPng.
			html break.
			html anchor
				callback: [self applyChanges];
				with: [html text: 'Apply changes' tr]
		].! !

!ITComponentAdminRoles methodsFor: 'rendering' stamp: 'mt 1/6/2008 00:22'!
renderAttachedUsersOn: html
	"Shows the current users which have the selected privilege attached."
	
	html fieldSet
		legend: 'Attached Users';
		with: [
			html unorderedList
				with: [
					self selectedRole users do: [:user | html listItem with: user username]
				]
		]! !

!ITComponentAdminRoles methodsFor: 'rendering' stamp: 'mt 1/6/2008 00:23'!
renderContentOn: html
	
	selectedRole isNil ifTrue: [selectedRole := ITGlorpSession getInstance readOneOf: ITRole].
	selectedRole isNil
			ifTrue: [
				html fieldSet
					legend: 'Add a new role' tr;
					with: [
						html span
							style: 'color: #000; font-weight: normal; ';
							with: 'There is no role available to be configured. You need to add a new one.' tr.
						html break.
						self renderNewRoleInputOn: html ].
				^nil.
			] ifFalse: [ self updatePrivileges ].

	html heading
		id: 'role_heading';
		level: 2;
		with: [ html text: 'Edit settings for role: ' tr, self selectedRole rolename ].
	
	html fieldSet
		legend: 'Select another role:' tr;
		with: [ self renderRoleSelectionOn: html ].
	
	html div
		id: 'privilege_lists';
		with: [ self renderPrivilegeListsOn: html ].
		
	html div
		id: 'attached_users';
		with: [ self renderAttachedUsersOn: html ].
	
	html fieldSet
		legend: 'Add a new role' tr;
		with: [ self renderNewRoleInputOn: html ].
	
	self renderDeleteRoleButtonOn: html.
	self renderApplyChangesButtonOn: html.! !

!ITComponentAdminRoles methodsFor: 'rendering' stamp: 'mt 1/5/2008 23:23'!
renderDeleteRoleButtonOn: html
	html div
		class: 'button';
		style: 'float: left; margin: 10px 5px';
		with: [
			html image url: ITFileLibrary / #deletePng.
			html break.
			html anchor
				callback: [self deleteRole];
				with: [html text: 'Delete Role' tr]
		].! !

!ITComponentAdminRoles methodsFor: 'rendering' stamp: 'mt 1/5/2008 22:50'!
renderListItems: aSelector on: html
	html unorderedList
		id: aSelector asString;
		script: (html sortable
			constraint: false;
			dropOnEmpty: true;
			containment: #( availablePrivileges attachedPrivileges );
			onUpdate: (html updater
				id: 'actual_privileges';
				triggerSortable: aSelector	callback: [ :values | self perform: aSelector asMutator with: values ]
			)
		);
		with: [
			(self perform: aSelector) do: [ :each |
				html listItem
					passenger: each;
					class: (aSelector = #availablePrivileges ifTrue: ['available'] ifFalse: ['attached']);
					with: each ] ]! !

!ITComponentAdminRoles methodsFor: 'rendering' stamp: 'mt 1/5/2008 22:27'!
renderNewRoleInputOn: html
	html form
		id: 'new_role_form';
		with: [
			html textInput on: #newRolename of: self.
			html submitButton 
				onClick: (html updater
					id: 'role_lists';
					triggerForm: 'new_role_form';
					callback: [:r | self addRole; updatePrivileges; renderPrivilegeListsOn: r]);
				value: 'add role' tr.
		].! !

!ITComponentAdminRoles methodsFor: 'rendering' stamp: 'mt 1/5/2008 22:34'!
renderPrivilegeListsOn: html

		html fieldSet
			class: 'drag_list';
			legend: 'Available Privileges' tr;
			with: [ self renderListItems: #availablePrivileges on: html ].
		html fieldSet
			class: 'drag_list';
			legend: 'Attached Privileges' tr;
			style: 'float: right;';
			with: [ self renderListItems: #attachedPrivileges on: html ].
		html div
			style: 'clear: both'.! !

!ITComponentAdminRoles methodsFor: 'rendering' stamp: 'mt 1/6/2008 00:24'!
renderRoleSelectionOn: html
	html form
		id: 'role_drop_down';
		with: [
			html select
				list: (ITGlorpSession getInstance read: ITRole);
				selected: selectedRole;
				labels: [:role|role rolename];
				callback: [ :value | selectedRole := value ];
				onChange: (html updater
					id: 'privilege_lists';
					triggerForm: 'role_drop_down';
					callback: [:r | self updatePrivileges; renderPrivilegeListsOn: r]);
				onChange: (html updater
					id: 'role_heading';
					triggerForm: 'role_drop_down';
					callback: [:r | r text: 'Edit settings for role: ' tr, self selectedRole rolename ]);
				onChange: (html updater
					id: 'attached_users';
					triggerForm: 'role_drop_down';
					callback: [:r | self renderAttachedUsersOn: r ]).										
		].! !

!ITComponentAdminRoles methodsFor: 'accessing' stamp: 'mt 1/5/2008 22:25'!
selectedRole
	^ selectedRole! !

!ITComponentAdminRoles methodsFor: 'accessing' stamp: 'mt 1/5/2008 22:25'!
selectedRole: anObject
	^ selectedRole := anObject! !

!ITComponentAdminRoles methodsFor: 'private' stamp: 'mt 1/5/2008 10:00'!
updatePrivileges
	"Updates the available and attached privileges to the current selected role."
	
	selectedRole notNil ifTrue: [
		self attachedPrivileges: selectedRole privileges.
		self availablePrivileges:	(
			ITSecurityManager privileges asSet collect: [:each |
				(selectedRole privileges includes: each) not ifTrue: [each]
			]
		)
	]! !

ITComponent subclass: #ITComponentAdminUsers
	instanceVariableNames: 'attachedRoles availableRoles selectedUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentAdminUsers methodsFor: 'private' stamp: 'mt 12/29/2007 12:24'!
applyChanges
	|session|
	session := ITGlorpSession getInstance.
	session inUnitOfWorkDo: [
		session register: selectedUser.
		selectedUser roles: self attachedRoles asSet.
		]! !

!ITComponentAdminUsers methodsFor: 'accessing' stamp: 'mt 12/29/2007 10:07'!
attachedRoles
	^ attachedRoles! !

!ITComponentAdminUsers methodsFor: 'accessing' stamp: 'mt 12/29/2007 10:07'!
attachedRoles: anObject
	attachedRoles := anObject! !

!ITComponentAdminUsers methodsFor: 'accessing' stamp: 'mt 12/29/2007 10:07'!
availableRoles
	^ availableRoles! !

!ITComponentAdminUsers methodsFor: 'accessing' stamp: 'mt 12/29/2007 10:07'!
availableRoles: anObject
	availableRoles := anObject! !

!ITComponentAdminUsers methodsFor: 'initialization' stamp: 'mt 1/5/2008 22:17'!
initialize
	super initialize.
	
	selectedUser := self session securityManager getUser: '*DEFAULT'.
	self updateRoles.! !

!ITComponentAdminUsers methodsFor: 'rendering' stamp: 'mt 1/5/2008 21:06'!
renderActualPrivilegesOn: html
	"Shows the current privileges the selected user would have if you apply/save the changes."
	
	| priv |
	priv := Set new.
	self attachedRoles do: [:role | priv := priv union: role privileges ].
	
	html fieldSet
		legend: 'Actual Privileges';
		with: [
			html unorderedList
				with: [
					priv do: [:privilege | html listItem with: privilege, ' ']
				]
		]! !

!ITComponentAdminUsers methodsFor: 'rendering' stamp: 'mt 1/5/2008 22:55'!
renderApplyChangesButtonOn: html
	html div
		class: 'button';
		with: [
			html image url: ITFileLibrary / #acceptPng.
			html break.
			html anchor
				callback: [self applyChanges];
				with: [html text: 'Apply changes' tr]
		].! !

!ITComponentAdminUsers methodsFor: 'rendering' stamp: 'mt 1/5/2008 22:55'!
renderContentOn: html
	
	
	html heading
		id: 'user_heading';
		level: 2;
		with: [ html text: 'Edit security settings for: ' tr, selectedUser username ].
	
	html fieldSet
		legend: 'Select another user:' tr;
		with: [ self renderUserSelectionOn: html ].
	
	html div
		id: 'role_lists';
		with: [ self renderRoleListsOn: html ].
		
	html div
		id: 'actual_privileges';
		with: [ self renderActualPrivilegesOn: html ].
		
	self renderApplyChangesButtonOn: html.! !

!ITComponentAdminUsers methodsFor: 'rendering' stamp: 'mt 1/5/2008 22:53'!
renderListItems: aSelector on: html
	html unorderedList
		id: aSelector asString;
		script: (html sortable
			constraint: false;
			dropOnEmpty: true;
			containment: #( availableRoles attachedRoles );
			onUpdate: (html updater
				id: 'actual_privileges';
				triggerSortable: aSelector	callback: [ :values | self perform: aSelector asMutator with: values ];
				callback: [ :renderer | self renderActualPrivilegesOn: renderer ]
			)
		);
		with: [
			(self perform: aSelector) do: [ :each |
				html listItem
					passenger: each;
					class: (aSelector = #availableRoles ifTrue: ['available'] ifFalse: ['attached']);
					with: each rolename tr] ]! !

!ITComponentAdminUsers methodsFor: 'rendering' stamp: 'mt 1/5/2008 21:10'!
renderRoleListsOn: html
		html fieldSet
			class: 'drag_list';
			legend: 'Available Roles';
			with: [ self renderListItems: #availableRoles on: html ].
		html fieldSet
			class: 'drag_list';
			legend: 'Attached Roles';
			style: 'float: right;';
			with: [ self renderListItems: #attachedRoles on: html ].
		html div
			style: 'clear: both'.! !

!ITComponentAdminUsers methodsFor: 'rendering' stamp: 'mt 1/6/2008 00:27'!
renderUserSelectionOn: html
	html form
		id: 'user_drop_down';
		with: [
			html select
				list: (ITGlorpSession getInstance read: ITUser);
				selected: selectedUser;
				labels: [:user|user username, ' (', user id asString, ')'];
				callback: [ :value | selectedUser := value ];
				onChange: (html updater
					id: 'role_lists';
					triggerForm: 'user_drop_down';
					callback: [:r | self updateRoles; renderRoleListsOn: r]);
				onChange: (html updater
					id: 'user_heading';
					triggerForm: 'user_drop_down';
					callback: [:r | r text: 'Edit security settings for: ' tr, selectedUser username]);
				onChange: (html updater
					id: 'actual_privileges';
					triggerForm: 'user_drop_down';
					callback: [:r | self renderActualPrivilegesOn: r ]).					
		]! !

!ITComponentAdminUsers methodsFor: 'private' stamp: 'mt 12/29/2007 12:44'!
updateRoles
	"Updates the available and attached roles to the current selected User."
	
	self attachedRoles: selectedUser roles.
	self availableRoles:	(
		(ITGlorpSession getInstance read: ITRole) asSet collect: [:each |
			(selectedUser roles includes: each) not ifTrue: [each]
		]
	).! !

ITComponent subclass: #ITComponentDetails
	instanceVariableNames: 'currentIssue addComment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentDetails class methodsFor: 'instance creation' stamp: 'mt 1/5/2008 10:33'!
newWith: anID
	|view|
	view := self new.
	
	[
	view currentIssue: (view session issueManager getIssueWithID: anID).
	view addComment: (ITComponentAddComment newWith: anID).
	]
		on: ITUnauthorizedError
		do: [view currentIssue: nil; addComment: nil].
		
	
	^view.! !

!ITComponentDetails methodsFor: 'accessing' stamp: 'mt 1/4/2008 23:36'!
addComment
	^ addComment! !

!ITComponentDetails methodsFor: 'accessing' stamp: 'mt 1/4/2008 23:36'!
addComment: anObject
	addComment := anObject! !

!ITComponentDetails methodsFor: 'accessing' stamp: 'mt 1/4/2008 23:41'!
children
	^ Array with: self addComment.! !

!ITComponentDetails methodsFor: 'accessing' stamp: 'mt 1/4/2008 22:40'!
currentIssue
	^ currentIssue! !

!ITComponentDetails methodsFor: 'accessing' stamp: 'mt 1/4/2008 22:40'!
currentIssue: anObject
	currentIssue := anObject! !

!ITComponentDetails methodsFor: 'rendering' stamp: 'mt 1/5/2008 11:27'!
renderCommentsOn: html
	
	(self currentIssue comments) do: [:comment |
		html div
			class: 'comment';
			with: [ 
				html heading: comment timestamp asString, ' by ' tr, comment user username level: 3.
				html text: comment content.
			]
	]! !

!ITComponentDetails methodsFor: 'rendering' stamp: 'afk 1/5/2008 20:37'!
renderContentOn: html
	"Show details of the current issue."

	html div
		class: 'content';
		with: [
			html anchor	
				callback: [self answer]; 
				with: '<< ','back to list' tr.
			
			self currentIssue isNil ifFalse: [
				html heading: 'Issue #', self currentIssue id asString level: 2.
				
				self renderDetailsOn: html.
				html heading: 'Comments:' level: 2.
				self renderCommentsOn: html.

				html render: self addComment.
			] ifTrue: [
				html break.
				html text: 'You are not authorized to view the details of an issue!!' tr.
			].
			
			
			5 timesRepeat: [html break]
		]
				! !

!ITComponentDetails methodsFor: 'rendering' stamp: 'afk 1/6/2008 01:14'!
renderDetailsOn: html

	html div
		id: 'issue';
		with: [
			"html heading: (self currentIssue getTag: 'title') level: 2.
			html table
				class: 'details';
				with: [
					html tableRow: [ 
						html tableHeading: 'Created by:' tr.
						html tableData: 'someBody'.
						html tableHeading: 'Assigned to:' tr.
						html tableData: 'aDeveloper'].
					html tableRow: [ 
						html tableHeading: 'Priority:' tr.
						html tableData: 'urgent'.
						html tableHeading: 'Version:' tr.
						html tableData: '1.0.0'].
					html tableRow: [ 
						html tableHeading: 'Color:' tr.
						html tableData: 'yellow'.
						html tableHeading: 'another tag:' tr.
						html tableData: 'another value'].
				]."
			html div
				class: 'description';
				with: [
					self currentIssue details do: [:each | 
													each tag = 'title' 	ifTrue: [html heading: (each content asString) level: 1.]
																		ifFalse: [	
																				html heading: (each tag asString) level: 3.
																				html paragraph: (each content asString).
																				].
												].
				]
		]! !

ITComponent subclass: #ITComponentListIssues
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentListIssues methodsFor: 'rendering' stamp: 'mt 1/5/2008 10:35'!
renderContentOn: html
	| issues |
	[issues := self session issueManager getIssues]
		on: ITUnauthorizedError
		do: [html text: 'You are not authorized to list all issues!!' tr. ^nil].

	html heading 
		level: 2;
		with: 'List all issues'.
	html form:[
		html table:[
			html tableRow: [
				html tableData: 'id'.
				html tableData: 'title'.
				html tableData: 'details'.
				html tableData: 'delete'.
				].
			issues do: [:issue|
				html tableRow: [
					html tableData: (issue id asString).
					html tableData: (issue getTag: 'title').
					html tableData: [
						html anchor 
							callback: [self call: (ITComponentDetails newWith: issue id)];
							with: [html text: 'detailed view'].
						].
					html tableData: [
						html anchor
							callback: [
								[((self session issueManager) deleteIssueWithID: issue id)]
									on: ITUnauthorizedError
									do: [self inform: 'You are not authorized to delete an issue!!' tr]
							];
							with: [html image url: ITFileLibrary / #binPng; altText: 'delete' tr ].
						].
					].
				].
			].
		].! !

ITComponent subclass: #ITComponentLogin
	instanceVariableNames: 'userInput passwordInput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentLogin methodsFor: 'accessing' stamp: 'mig 12/17/2007 13:42'!
passwordInput
	^ passwordInput! !

!ITComponentLogin methodsFor: 'accessing' stamp: 'mig 12/17/2007 13:42'!
passwordInput: anObject
	passwordInput := anObject! !

!ITComponentLogin methodsFor: 'rendering' stamp: 'afk 12/31/2007 15:05'!
renderContentOn: html

	html div style: 'background: white; padding: 20px;'; with: [
		html form: [
			html text: 'username:'.
			html textInput on: #userInput of: self.
			html break.
			html text: 'password:'.
			html passwordInput on: #passwordInput of: self.
			html break.
			html submitButton callback: [
				| valid |
				valid := self session securityManager validatePassword: self passwordInput for: self userInput.
				valid ifTrue: [
					self session user: (self session securityManager getUser: userInput).
					self answer: true.
				] ifFalse: [
					self inform: 'Wrong username/password combination!!'.
				].
			]; value: 'Login'.
			html cancelButton callback: [
				self answer: false.
			]; value: 'Cancel'.
		].
	].! !

!ITComponentLogin methodsFor: 'accessing' stamp: 'mig 12/17/2007 13:42'!
userInput
	^ userInput! !

!ITComponentLogin methodsFor: 'accessing' stamp: 'mig 12/17/2007 13:42'!
userInput: anObject
	userInput := anObject! !

ITComponent subclass: #ITComponentMenu
	instanceVariableNames: 'tabs selected userStatus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentMenu class methodsFor: 'testing' stamp: 'mt 11/23/2007 18:52'!
canBeRoot
	^true.! !

!ITComponentMenu methodsFor: 'initialize' stamp: 'afk 1/5/2008 00:45'!
children
	^Array with: self selected with: self userStatus.! !

!ITComponentMenu methodsFor: 'initialize' stamp: 'mt 1/5/2008 19:40'!
initialize
	super initialize.
	self userStatus: ITComponentUserStatus new.
	self tabs: ((OrderedCollection new)
				add: 'View Issues' -> ITComponentListIssues new;
				add: 'New Issue' -> ITComponentAddIssue new;
				add: 'Administration' -> ITComponentAdmin new;
				yourself).
	self selected: self tabs first value! !

!ITComponentMenu methodsFor: 'rendering' stamp: 'afk 1/4/2008 17:34'!
renderChildrenOn: html
	html div
		with: [
			html render: self selected.
		]! !

!ITComponentMenu methodsFor: 'rendering' stamp: 'mt 12/30/2007 20:40'!
renderContentOn: html

	html heading
		level: 1;
		with: 'IssueTracker'.
		
	self renderLoginMenuOn: html.
	self renderMainMenuOn: html.
	self renderChildrenOn: html.! !

!ITComponentMenu methodsFor: 'rendering' stamp: 'afk 1/5/2008 01:02'!
renderLoginMenuOn: html
	html div
		id: 'login_menu';
		with: [
			html render: self userStatus.
			html text: ' | '.
			html span
				script: (html updater
						every: 1 second;
						on: #renderTimeOn: of: self);
				with: [ self renderTimeOn: html ]
			]! !

!ITComponentMenu methodsFor: 'rendering' stamp: 'afk 1/5/2008 20:00'!
renderMainMenuOn: html
	html div
		id: 'main_menu';
		class: 'menu';
		with: [
			html unorderedList
				with: [
					self tabs do: [ :tab |
						html listItem
							class: (self selected = tab value ifTrue: ['active']);
							with: [ 
							html anchor 
								callback: [ self selected: tab value];
								with: tab key
						]
					]
				]   
		].! !

!ITComponentMenu methodsFor: 'rendering' stamp: 'afk 12/31/2007 15:01'!
renderTimeOn: html
	html render: Time now print24.! !

!ITComponentMenu methodsFor: 'accessing' stamp: 'afk 12/30/2007 22:34'!
selected
	^ selected! !

!ITComponentMenu methodsFor: 'accessing' stamp: 'afk 12/30/2007 22:34'!
selected: anObject
	^ selected := anObject! !

!ITComponentMenu methodsFor: 'accessing' stamp: 'afk 12/30/2007 22:32'!
tabs
	^ tabs! !

!ITComponentMenu methodsFor: 'accessing' stamp: 'afk 12/30/2007 22:32'!
tabs: anObject
	tabs := anObject! !

!ITComponentMenu methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:36'!
userStatus
	^ userStatus! !

!ITComponentMenu methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:36'!
userStatus: anObject
	userStatus := anObject! !

ITComponent subclass: #ITComponentUserRegister
	instanceVariableNames: 'userInput passwordInput1 passwordInput2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentUserRegister methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:00'!
passwordInput1
	^ passwordInput1! !

!ITComponentUserRegister methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:00'!
passwordInput1: anObject
	passwordInput1 := anObject! !

!ITComponentUserRegister methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:00'!
passwordInput2
	^ passwordInput2! !

!ITComponentUserRegister methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:00'!
passwordInput2: anObject
	passwordInput2 := anObject! !

!ITComponentUserRegister methodsFor: 'rendering' stamp: 'afk 12/31/2007 15:03'!
renderContentOn: html
	html div style: 'background: white; padding: 20px;'; with: [
		html form: [
			html text: 'username:'.
			html textInput on: #userInput of: self.
			html break.
			html text: 'password:'.
			html passwordInput on: #passwordInput1 of: self.
			html break.
			html text: 'verify:'.
			html passwordInput on: #passwordInput2 of: self.
			html break.
			html submitButton callback: [
				| user |
				(self session securityManager getUser: self userInput) ifNotNil: [
					self inform: 'Username already exists!!'.
				] ifNil: [
					self passwordInput1 = self passwordInput2 ifFalse: [
						self inform: 'Passwords do not match!!'.
					] ifTrue:	[
						user := ITUser new.
						user 
							username: self userInput;
							setPassword: self passwordInput1.
						self session securityManager addUser: user.
						self answer: true.]
				].
			]; value: 'Register'.
			html cancelButton callback: [
			self answer: false.
			]; value: 'Cancel'.
		].
	].! !

!ITComponentUserRegister methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:00'!
userInput
	^ userInput! !

!ITComponentUserRegister methodsFor: 'accessing' stamp: 'mig 12/17/2007 14:00'!
userInput: anObject
	userInput := anObject! !

ITComponent subclass: #ITComponentUserStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentUserStatus methodsFor: 'rendering' stamp: 'mt 1/5/2008 11:57'!
renderContentOn: html
	self session isLoggedIn ifFalse: [
		html anchor
			callback: [ self lightbox: ITComponentLogin new ]; 
			with: [ html text: 'Login'].
		html text: ' | '.
		html anchor 
			callback: [ self lightbox: ITComponentUserRegister new ]; 
			with: [ html text: 'Register'].
	] ifTrue: [
		html span
			class: 'text';
			with: 'logged in as ', self session user username.
		html text: ' | '.
		html anchor
			callback: [self session user: nil.];
			with: 'Logout'.
	].! !

GlorpSession subclass: #ITGlorpSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

ITGlorpSession class
	instanceVariableNames: 'instance'!

!ITGlorpSession commentStamp: 'mt 12/15/2007 10:12' prior: 0!
I'm a usual GlorpSession and control a cache manager, a description system and all unit of works. Every manipulation of the SQL database goes through my "fingers".

Use #inUnitOfWorkDo: for watching over "dirty" objects and change all relevant data in the database. But DO NOT forget to register them with #register inside a unit of work.

Any read of data doesn't have to be embedded in a unit of work. Just use the result of #read:, #readOneOf:, #readManyOf:, #read:where: a. s. o.

If you want to delete an object you doesn't have to use a unit of work either.!

ITGlorpSession class
	instanceVariableNames: 'instance'!

!ITGlorpSession class methodsFor: 'accessing' stamp: 'afk 12/15/2007 13:10'!
getInstance
	"Using singleton pattern to ensure that there is only one instance of ITGlorpSession"
	
	instance ifNil:
		[ instance := ITGlorpDB connect.].
	instance isLoggedIn ifFalse:
		[ instance := ITGlorpDB connect.].
	^ instance! !

!ITGlorpSession class methodsFor: 'instance creation' stamp: 'mt 12/26/2007 10:52'!
new
	Error signal: 'Use getInstance because', self name, ' is a singleton.'! !

DescriptorSystem subclass: #ITGlorpDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITGlorpDescriptorSystem commentStamp: 'mt 12/30/2007 14:38' prior: 0!
I'm the descriptor system that should be used in every new ITGlorpSession. I'm responsible for all mappings between the IT-Classes and the relevant tables on the SQL server.

You should modify #allTableNames and #constructAllClasses whenever you want to add new objects of the domain space for usage here.

#tableNamed<TABLE_NAME>    ... descriptions about the table structure on the server
#descriptorFor<CLASS_NAME> ... defines mappings between classes and tables
#classModelFor<CLASS_NAME> ... defines types (classes) for symbols (attributes) used by mappings

The relational schemes can be found in the comments for any #tableNamed<TABLE_NAME>. Primary keys are underlined, e.g. 

SCHEME(ATTRIBUTE_A, ATTRIBUTE_B)
                    -----------!

!ITGlorpDescriptorSystem methodsFor: 'accessing' stamp: 'mig 12/16/2007 19:19'!
allTableNames
	"Here are all tables listed which hold all persistent data."
	
	^ #('ISSUE' 'COMMENT' 'DETAIL' 'USERS' 'ROLE' 'USERROLE' 'ROLEPRIVILEGE')! !

!ITGlorpDescriptorSystem methodsFor: 'class models' stamp: 'mt 12/14/2007 09:54'!
classModelForITIssue: aClassModel
	"The unique ID can be up to 1.073.741.823 - should be enough.
	 -> SmallInteger maxVal
	 4-Byte-Integers (signed) are used in the database"
	
	aClassModel newAttributeNamed: #id type: SmallInteger.
	aClassModel newAttributeNamed: #comments collection: OrderedCollection  of: ITIssueComment.
	aClassModel newAttributeNamed: #details collection: OrderedCollection  of: ITIssueDetail.! !

!ITGlorpDescriptorSystem methodsFor: 'class models' stamp: 'mt 1/5/2008 11:16'!
classModelForITIssueComment: aClassModel
	"See #classModelForITIssue for explanation of ID."
	
	aClassModel newAttributeNamed: #id type: SmallInteger.
	aClassModel newAttributeNamed: #content type: String.
	aClassModel newAttributeNamed: #timestamp type: TimeStamp.
	aClassModel newAttributeNamed: #user type: ITUser.! !

!ITGlorpDescriptorSystem methodsFor: 'class models' stamp: 'mt 12/14/2007 09:55'!
classModelForITIssueDetail: aClassModel
	"See #classModelForITIssue for explanation of ID."

	aClassModel newAttributeNamed: #id type: SmallInteger.
	aClassModel newAttributeNamed: #tag type: String.
	aClassModel newAttributeNamed: #content type: String.! !

!ITGlorpDescriptorSystem methodsFor: 'class models' stamp: 'mt 1/5/2008 23:28'!
classModelForITRole: aClassModel

	aClassModel newAttributeNamed: #id type: SmallInteger.
	aClassModel newAttributeNamed: #rolename type: String.
	aClassModel newAttributeNamed: #privileges collection: Set of: String.
	aClassModel newAttributeNamed: #users collection: Set of: ITUser.
	! !

!ITGlorpDescriptorSystem methodsFor: 'class models' stamp: 'mig 12/17/2007 14:57'!
classModelForITUser: aClassModel

	aClassModel newAttributeNamed: #id type: SmallInteger.
	aClassModel newAttributeNamed: #username type: String.
	aClassModel newAttributeNamed: #passwordHash type: String.
	aClassModel newAttributeNamed: #roles collection: Set of: ITRole.
! !

!ITGlorpDescriptorSystem methodsFor: 'accessing' stamp: 'mig 12/16/2007 19:41'!
constructAllClasses
	"Here are all classes listed which are necessary for the mappings."
	
	^ (super constructAllClasses)
		add: ITIssue;
		add: ITIssueComment;
		add: ITIssueDetail;
		add: ITUser;
		add: ITRole;
		yourself! !

!ITGlorpDescriptorSystem methodsFor: 'descriptors' stamp: 'mt 12/14/2007 09:45'!
descriptorForITIssue: aDescriptor
	"Every issue contains a unique ID, a collection of comments and a collection of details."
	
	| issueTable commentTable detailTable |
	issueTable   := self tableNamed: 'ISSUE'.
	commentTable := self tableNamed: 'COMMENT'.
	detailTable  := self tableNamed: 'DETAIL'.

	aDescriptor table: issueTable.
	
	(aDescriptor newMapping: DirectMapping) from: #id to: (issueTable fieldNamed: 'ID').

	(aDescriptor newMapping: ToManyMapping)
		attributeName: #comments;
		join: (Join
			from: (issueTable fieldNamed: 'ID')
			to: (commentTable	fieldNamed: 'ISSUE_ID')
		).
	
	(aDescriptor newMapping: ToManyMapping)
		attributeName: #details;
		join: (Join
			from: (issueTable fieldNamed: 'ID')
			to:  (detailTable fieldNamed: 'ISSUE_ID')
		).! !

!ITGlorpDescriptorSystem methodsFor: 'descriptors' stamp: 'mt 1/5/2008 11:04'!
descriptorForITIssueComment: aDescriptor
	"Every comment contains a unique ID and its content - should be text."
	
	| table |
	table := self tableNamed: 'COMMENT'.
	aDescriptor table: table.
	
	(aDescriptor newMapping: DirectMapping) from: #id to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #content to: (table fieldNamed: 'CONTENT').
	(aDescriptor newMapping: DirectMapping) from: #timestamp to: (table fieldNamed: 'TIMESTAMP').

	(aDescriptor newMapping: OneToOneMapping)
		attributeName: #user.! !

!ITGlorpDescriptorSystem methodsFor: 'descriptors' stamp: 'mt 12/14/2007 09:47'!
descriptorForITIssueDetail: aDescriptor
	"Every detail contains a unique ID, a tag and its content."

	| table |
	table := self tableNamed: 'DETAIL'.
	aDescriptor table: table.
	
	(aDescriptor newMapping: DirectMapping) from: #id to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #tag to: (table fieldNamed: 'TAG').
	(aDescriptor newMapping: DirectMapping) from: #content to: (table fieldNamed: 'CONTENT').! !

!ITGlorpDescriptorSystem methodsFor: 'descriptors' stamp: 'mig 12/16/2007 19:26'!
descriptorForITRole: aDescriptor
	
	| roleTable userRoleTable rolePrivilegeTable |
	roleTable := self tableNamed: 'ROLE'.
	userRoleTable := self tableNamed: 'USERROLE'.
	rolePrivilegeTable := self tableNamed: 'ROLEPRIVILEGE'.

	aDescriptor table: roleTable.
	
	(aDescriptor newMapping: DirectMapping) from: #id to: (roleTable fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #rolename to: (roleTable fieldNamed: 'ROLENAME').

	(aDescriptor newMapping: ManyToManyMapping)
		attributeName: #users;
		referenceClass: ITUser;
		mappingCriteria: (Join
			from: (roleTable fieldNamed: 'ID')
			to:  (userRoleTable fieldNamed: 'ROLE_ID')
		).
	
	(aDescriptor newMapping: DirectToManyMapping)
		attributeName: #privileges;
		resultField: (rolePrivilegeTable fieldNamed: 'PRIVILEGE');
		writeTheOrderField;
		orderBy: [:each | (each getTable: rolePrivilegeTable) getField: 'PRIVILEGE_ORDER'];
		join: (Join from: (roleTable fieldNamed: 'ID') to: (rolePrivilegeTable fieldNamed: 'ROLE_ID')).! !

!ITGlorpDescriptorSystem methodsFor: 'descriptors' stamp: 'mig 12/16/2007 19:41'!
descriptorForITUser: aDescriptor
	
	| userTable userRoleTable |
	userTable   := self tableNamed: 'USERS'.
	userRoleTable := self tableNamed: 'USERROLE'.

	aDescriptor table: userTable.
	
	(aDescriptor newMapping: DirectMapping) from: #id to: (userTable fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #username to: (userTable fieldNamed: 'USERNAME').
	(aDescriptor newMapping: DirectMapping) from: #passwordHash to: (userTable fieldNamed: 'PASSWORDHASH').

	(aDescriptor newMapping: ManyToManyMapping)
		attributeName: #roles;
		referenceClass: ITRole;
		mappingCriteria: (Join
			from: (userTable fieldNamed: 'ID')
			to:  (userRoleTable fieldNamed: 'USER_ID')
		).! !

!ITGlorpDescriptorSystem methodsFor: 'tables' stamp: 'mt 1/5/2008 10:57'!
tableForCOMMENT: aTable
	"COMMENTS(ID, ISSUE_ID, TIMESTAMP, CONTENT)
	          --"
	
	| issueId userId|
	(aTable createFieldNamed: 'ID' type: (platform sequence)) bePrimaryKey.
	issueId := aTable createFieldNamed: 'ISSUE_ID' type: (platform int4).
	userId := aTable createFieldNamed: 'USER_ID' type: (platform int4).	
	aTable createFieldNamed: 'TIMESTAMP' type: (platform timestamp).
	aTable createFieldNamed: 'CONTENT' type: (platform text).
	
	"foreign key definition for the IDs of issues"
	aTable 
		addForeignKeyFrom: issueId 
		to: ((self tableNamed: 'ISSUE') fieldNamed: 'ID')
		suffixExpression: 'ON DELETE CASCADE'.
	aTable 
		addForeignKeyFrom: userId 
		to: ((self tableNamed: 'USERS') fieldNamed: 'ID')
		suffixExpression: 'ON DELETE CASCADE'.! !

!ITGlorpDescriptorSystem methodsFor: 'tables' stamp: 'mt 12/15/2007 14:28'!
tableForDETAIL: aTable
	"DETAIL(ID, ISSUE_ID, TAG, CONTENT)
	       --"
	
	| issueID |
	(aTable createFieldNamed: 'ID' type: (platform sequence)) bePrimaryKey.
	issueID := (aTable createFieldNamed: 'ISSUE_ID' type: (platform int4)).
	aTable createFieldNamed: 'TAG' type: (platform varchar: 255).
	aTable createFieldNamed: 'CONTENT' type: (platform varchar: 255).
	
	"foreign key definition for IDs of issues"
	aTable
		addForeignKeyFrom: issueID
		to: ((self tableNamed: 'ISSUE') fieldNamed: 'ID')
		suffixExpression: 'ON DELETE CASCADE'.! !

!ITGlorpDescriptorSystem methodsFor: 'tables' stamp: 'mt 12/14/2007 09:38'!
tableForISSUE: aTable
	"ISSUE(ID)
	       --"
	
	(aTable createFieldNamed: 'ID' type: (platform sequence)) bePrimaryKey.! !

!ITGlorpDescriptorSystem methodsFor: 'tables' stamp: 'mig 12/17/2007 00:50'!
tableForROLE: aTable
	"ROLE(ID, ROLENAME)"
	
	(aTable createFieldNamed: 'ID' type: platform sequence) bePrimaryKey.
	aTable createFieldNamed: 'ROLENAME' type: (platform varchar: 255).! !

!ITGlorpDescriptorSystem methodsFor: 'tables' stamp: 'mig 12/17/2007 14:51'!
tableForROLEPRIVILEGE: aTable
	"ROLEPRIVILEGE(ROLE_ID, PRIVILEGE, PRIVILEGE_ORDER)"
	
	| roleid privilege |
	
	roleid := aTable createFieldNamed: 'ROLE_ID' type: platform int4.
	privilege := aTable createFieldNamed: 'PRIVILEGE' type: platform text.
	aTable createFieldNamed: 'PRIVILEGE_ORDER' type: platform int4.
	
	roleid bePrimaryKey.
	privilege bePrimaryKey.
	
	aTable 
		addForeignKeyFrom: roleid 
		to: ((self tableNamed: 'ROLE') fieldNamed: 'ID')
		suffixExpression: 'ON DELETE CASCADE'.
! !

!ITGlorpDescriptorSystem methodsFor: 'tables' stamp: 'mt 1/6/2008 00:03'!
tableForUSERROLE: aTable
	"USERROLE(USER_ID, ROLE_ID)"

	| userid roleid |
	
	userid := aTable createFieldNamed: 'USER_ID' type: (platform int4).
	roleid := aTable createFieldNamed: 'ROLE_ID' type: (platform int4).
		
	aTable 
		addForeignKeyFrom: userid 
		to: ((self tableNamed: 'USERS') fieldNamed: 'ID')
		suffixExpression: 'ON DELETE CASCADE'.
		
	aTable 
		addForeignKeyFrom: roleid 
		to: ((self tableNamed: 'ROLE') fieldNamed: 'ID')
		suffixExpression: 'ON DELETE CASCADE'.
! !

!ITGlorpDescriptorSystem methodsFor: 'tables' stamp: 'mig 12/17/2007 01:02'!
tableForUSERS: aTable
	"USERS(ID, USERNAME, PASSWORDHASH)"
	
	(aTable createFieldNamed: 'ID' type: platform sequence) bePrimaryKey.
	aTable createFieldNamed: 'USERNAME' type: (platform varchar: 255).
	aTable createFieldNamed: 'PASSWORDHASH' type: (platform varchar: 255).! !

WAFileLibrary subclass: #ITFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITFileLibrary commentStamp: 'mt 12/30/2007 14:39' prior: 0!
This is the place for all (former) external resources. Style sheets, images, other files. You have access to these files with: "ITFileLibrary / #filenameExtension" which creates you a WAUrl instance for proper usage.

You should modify these files through the web frontend of seaside. But feel free to modify my methods as well.!

!ITFileLibrary methodsFor: 'uploaded' stamp: ''!
acceptPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 159 73 68 65 84 56 203 165 147 235 75 83 97 28 199 253 59 118 206 118 108 3 9 100 68 33 130 132 80 123 21 36 18 59 154 13 197 188 44 75 211 221 189 210 54 99 216 76 139 50 114 94 198 72 41 45 179 212 106 115 78 109 234 212 230 214 148 50 113 217 81 66 204 189 233 66 181 97 116 177 111 231 236 197 76 18 35 122 224 11 15 15 207 231 243 123 174 113 0 226 254 39 127 12 20 248 14 137 114 167 15 234 179 61 41 76 198 227 253 97 233 136 56 44 117 37 50 82 103 162 62 221 190 87 180 171 32 207 155 74 203 60 201 33 157 71 134 155 65 11 250 150 187 162 233 92 108 70 137 235 24 36 189 84 72 210 67 209 59 10 216 170 116 230 120 82 228 234 156 17 206 213 126 216 94 94 131 105 174 50 26 174 239 88 237 67 227 76 21 14 216 248 145 100 27 159 222 38 200 241 164 8 51 221 73 235 28 204 77 172 9 148 161 194 95 2 205 204 25 232 216 148 179 169 246 157 133 253 245 61 92 156 170 128 216 66 174 139 175 147 194 152 64 230 78 50 168 198 178 162 149 57 152 3 85 222 83 80 76 23 66 49 85 0 245 84 33 220 107 131 48 120 149 112 176 146 220 158 35 72 184 66 26 98 130 140 17 49 211 25 108 134 53 216 132 10 95 49 148 79 228 44 152 15 229 36 27 79 62 198 223 184 192 181 80 100 13 109 207 27 97 155 107 68 124 61 201 196 4 71 237 9 27 15 86 110 163 54 160 129 214 91 196 174 100 0 139 31 230 161 154 40 196 216 218 80 20 254 177 249 29 109 207 46 193 48 81 140 190 96 39 4 70 98 35 38 144 220 167 54 250 151 187 97 244 171 80 235 215 226 211 215 143 81 232 253 151 183 49 216 50 91 15 181 43 27 122 247 105 244 7 59 32 168 249 93 208 67 49 55 230 155 208 190 112 25 186 73 57 204 190 106 68 190 125 142 194 155 63 55 97 121 122 1 101 206 44 104 88 65 75 160 14 237 94 51 168 42 98 107 11 169 183 4 6 249 64 26 236 43 119 81 61 33 135 218 125 18 117 211 229 88 122 183 128 182 217 6 148 14 30 135 194 113 2 58 103 14 236 175 186 145 110 61 12 170 146 216 58 196 100 43 95 184 143 189 26 179 71 131 135 204 29 84 142 230 65 59 156 3 213 144 12 74 7 23 14 206 198 163 165 46 24 135 138 33 80 243 214 41 53 33 220 246 144 18 155 72 58 190 129 136 152 220 101 112 176 146 214 128 25 250 209 34 156 27 150 163 149 221 130 157 133 245 206 34 240 75 121 17 22 166 119 124 202 123 26 72 154 50 17 33 105 135 4 237 126 51 122 95 88 209 59 111 133 197 107 66 90 75 42 4 10 94 136 82 17 244 174 159 137 58 79 138 40 3 161 167 106 8 70 160 229 133 5 42 94 152 173 200 176 209 83 165 132 232 175 191 241 95 243 11 103 208 172 229 121 186 212 99 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!ITFileLibrary methodsFor: 'uploaded' stamp: ''!
addPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 111 73 68 65 84 56 203 165 147 235 75 147 97 24 135 253 91 182 47 5 131 164 134 89 40 168 41 37 88 40 111 217 108 138 138 78 219 150 115 107 138 206 246 110 46 157 186 205 3 45 157 19 15 21 181 161 219 104 164 59 56 15 195 3 102 226 212 210 69 234 235 80 162 141 34 8 106 195 175 191 222 21 77 71 203 136 30 248 125 121 224 186 158 231 190 185 239 36 0 73 255 147 223 46 116 211 117 204 14 143 132 108 117 137 168 230 9 65 88 254 162 58 220 240 188 130 146 90 203 72 209 104 49 243 68 129 110 90 74 180 79 74 66 207 214 123 177 26 90 132 255 243 6 214 63 173 96 50 96 135 210 83 3 190 137 19 226 61 185 78 36 20 252 132 197 145 233 61 59 14 190 237 97 246 131 11 38 106 16 143 119 12 176 239 155 176 244 113 14 218 5 25 74 71 242 35 220 193 60 34 78 160 157 146 50 104 56 232 222 181 96 239 235 54 134 183 245 120 184 214 129 110 95 43 12 126 29 250 252 90 116 111 182 192 125 96 7 233 17 162 208 120 37 88 208 155 205 136 9 104 88 209 191 172 198 187 47 155 244 139 125 232 221 210 66 243 74 137 95 71 189 38 131 124 81 8 197 114 45 156 251 54 220 28 201 65 222 131 12 69 76 208 226 172 161 92 1 27 253 85 51 58 87 85 104 91 145 67 54 43 138 9 4 54 46 26 102 202 32 157 42 198 192 27 29 244 75 205 184 220 157 70 197 4 138 113 254 161 247 189 11 253 111 117 52 220 132 63 29 241 100 17 20 243 124 88 252 195 200 210 165 30 198 4 77 118 222 225 68 96 12 218 13 18 42 95 253 137 2 210 91 13 171 127 8 233 29 236 35 65 189 173 156 50 250 180 48 108 105 208 244 82 8 241 124 5 120 214 27 113 96 52 119 61 92 244 251 212 232 242 222 195 5 117 242 81 9 226 177 18 197 109 43 1 71 192 2 217 124 37 36 222 210 31 53 31 23 136 156 28 212 185 139 225 216 53 227 82 79 42 216 247 89 71 77 20 154 139 24 85 79 11 131 164 71 128 113 106 52 214 176 40 88 235 140 38 10 115 49 177 99 194 29 203 173 40 28 76 86 158 102 196 13 82 249 163 2 162 100 232 106 164 209 81 9 39 45 49 250 218 65 206 84 65 62 85 9 227 106 27 28 52 44 180 112 192 86 177 34 52 76 36 28 101 206 64 46 65 24 114 66 249 3 153 232 89 32 97 126 109 128 121 195 0 141 183 17 89 93 41 81 56 116 28 78 184 76 215 244 153 204 220 158 116 50 187 243 34 149 161 73 9 167 181 159 13 159 111 61 67 157 83 177 200 100 229 41 230 95 183 241 95 243 29 65 70 203 31 0 40 211 193 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!ITFileLibrary methodsFor: 'uploaded' stamp: ''!
binPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 4 0 0 0 181 250 55 234 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 1 110 73 68 65 84 24 25 5 193 191 75 84 113 0 0 240 207 123 94 202 157 215 21 69 22 53 84 168 68 100 17 221 210 208 32 68 129 109 70 109 246 7 164 155 213 214 218 84 91 52 59 244 131 22 201 90 130 104 9 196 254 0 27 36 78 7 3 15 2 233 56 61 125 119 239 251 222 183 207 39 137 0 0 214 158 141 76 116 222 222 94 5 146 8 128 167 183 226 189 201 7 179 147 85 91 217 187 55 253 149 215 171 136 162 40 138 158 204 45 182 190 197 141 184 31 139 248 55 126 143 11 173 249 185 40 5 32 157 191 63 62 233 164 125 125 195 174 154 30 79 231 169 0 159 147 194 212 212 21 137 3 35 50 163 118 53 109 93 167 194 151 161 242 124 113 182 24 62 86 111 153 80 85 74 28 56 225 43 85 42 148 151 138 231 97 58 212 179 164 106 195 161 68 48 34 115 193 22 42 159 234 197 171 169 153 211 142 232 88 183 109 92 162 16 4 29 3 164 225 238 216 204 25 135 50 13 55 29 181 105 84 162 166 45 202 145 230 143 47 218 181 167 107 95 162 105 83 148 26 50 16 229 72 243 83 21 127 100 50 61 7 234 186 254 129 129 66 142 116 176 221 115 89 219 47 93 61 244 245 149 74 185 82 64 58 248 248 91 221 53 55 52 144 43 28 87 138 134 212 228 72 23 62 172 47 255 208 208 80 85 179 102 194 152 115 26 238 104 11 59 84 24 60 252 185 220 157 109 42 229 86 98 61 121 41 8 138 188 216 41 154 36 17 44 62 202 95 132 118 216 11 239 151 150 0 128 255 200 133 159 94 23 25 132 161 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!ITFileLibrary methodsFor: 'uploaded' stamp: ''!
cancelPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 1 221 73 68 65 84 56 203 165 147 107 107 26 65 20 134 247 107 72 32 33 41 166 52 132 150 94 99 155 160 168 161 198 152 20 52 101 141 74 155 218 75 164 105 40 189 209 203 255 204 135 92 32 127 163 196 149 160 178 206 174 187 59 79 103 86 55 85 148 150 210 15 47 11 195 190 207 153 247 156 51 6 96 252 143 198 15 13 195 10 143 7 10 70 101 253 25 96 24 13 30 221 135 239 239 224 219 1 242 235 91 228 151 58 242 211 27 228 135 87 248 15 110 227 25 70 123 50 32 50 255 56 4 179 136 204 100 144 169 20 65 50 73 176 182 134 159 207 226 31 62 167 119 239 38 66 255 59 2 24 54 31 212 225 252 28 89 171 17 36 18 4 171 171 248 149 10 242 236 12 175 90 194 219 223 197 189 179 140 61 128 68 128 254 149 85 101 109 166 211 129 102 19 191 90 197 47 151 193 82 209 219 109 228 201 9 189 196 67 122 47 10 116 66 235 16 32 204 155 78 19 236 237 133 230 8 18 74 155 21 164 183 189 141 179 184 136 251 236 9 173 97 128 238 176 252 188 255 59 175 186 114 100 12 165 204 238 214 22 78 44 134 88 88 192 169 228 39 0 62 190 238 231 141 199 241 75 165 17 128 174 238 230 114 136 249 121 186 179 179 56 165 236 56 32 120 95 195 95 89 193 55 205 171 204 250 171 205 180 90 200 139 11 132 154 140 61 61 141 243 116 157 203 97 128 167 1 106 68 222 227 20 242 244 180 95 181 209 192 221 220 196 217 216 8 205 82 65 130 163 35 186 203 215 17 197 244 40 192 85 27 166 231 235 213 203 120 102 129 224 248 56 52 235 188 221 185 57 132 110 174 50 139 245 36 98 39 67 123 233 26 77 195 248 57 178 72 106 57 44 61 223 222 203 29 220 248 221 171 188 246 204 12 246 212 20 246 82 44 172 220 26 50 143 173 178 90 14 203 190 117 3 183 154 199 217 205 225 152 217 48 175 40 102 16 133 212 152 121 226 99 82 221 181 116 135 35 93 14 212 236 171 249 247 215 248 143 250 5 231 149 184 131 253 158 221 191 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!ITFileLibrary methodsFor: 'uploaded' stamp: ''!
deletePng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 93 73 68 65 84 56 203 165 147 251 75 83 97 24 199 253 91 182 31 162 4 137 110 132 132 81 80 152 243 50 119 214 218 220 166 206 179 76 143 91 44 98 105 142 157 97 154 65 141 197 92 248 67 168 165 118 213 202 95 50 77 108 148 90 70 106 215 161 229 177 242 210 78 77 106 109 158 179 107 202 183 185 96 38 46 35 122 225 251 203 203 251 249 188 60 15 207 147 2 32 229 127 178 230 98 86 175 23 206 80 21 230 247 84 25 51 165 37 185 73 173 134 123 71 170 153 113 82 105 118 149 200 133 235 10 230 116 122 226 35 69 177 223 28 54 132 7 157 136 188 25 69 100 100 8 252 221 14 204 26 74 241 170 144 96 159 171 197 68 82 193 50 60 93 78 241 11 183 59 176 52 245 22 209 190 59 136 182 219 17 109 62 135 31 55 155 176 56 220 7 143 201 128 81 101 54 255 76 158 73 172 18 204 232 116 130 24 236 230 174 183 99 137 113 33 122 241 12 124 118 11 252 182 106 132 47 88 16 105 160 17 182 158 64 248 222 13 204 29 37 49 124 104 159 251 177 108 143 32 33 136 193 244 124 173 25 139 174 177 248 143 33 7 13 239 89 35 130 117 186 85 225 78 146 8 119 93 193 203 188 12 12 72 51 232 132 224 3 117 132 9 116 93 69 180 179 25 62 107 37 190 22 73 147 102 161 146 4 111 171 129 199 82 133 135 68 58 147 16 48 229 218 96 228 126 23 162 14 11 124 167 13 248 211 241 40 114 224 165 10 225 111 110 132 51 111 71 48 33 152 36 139 130 161 206 86 132 235 13 8 158 42 91 87 48 95 170 130 191 169 17 253 226 45 43 130 137 18 21 227 181 214 32 100 167 193 29 87 199 31 38 141 50 15 190 90 19 102 77 70 244 137 210 86 74 112 21 203 105 70 38 66 176 179 13 62 173 12 222 82 201 26 152 149 103 131 45 144 32 208 126 9 67 226 109 232 205 218 180 210 196 215 69 82 193 11 13 225 158 171 208 32 112 171 53 222 176 121 149 248 23 168 200 5 43 139 193 50 49 248 182 22 140 23 75 151 97 119 183 104 163 96 213 32 141 21 228 16 35 138 3 252 244 97 21 2 215 90 241 189 158 134 135 84 226 179 90 1 111 157 25 252 229 22 76 168 243 209 147 149 202 199 96 34 233 40 63 149 239 39 158 28 220 203 142 74 118 225 75 181 17 222 134 243 241 124 170 58 134 71 57 91 151 97 246 119 56 233 50 13 74 119 11 7 196 233 102 39 177 147 121 144 191 157 235 23 109 230 122 115 211 152 158 236 84 115 119 230 6 225 95 183 241 95 243 19 29 210 206 185 73 114 27 254 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!ITFileLibrary methodsFor: 'uploaded' stamp: ''!
mainCss
	^ '/* general settings for all components */
body {
	margin: 0px;
	font: 11px Lucida Grande, Verdana, Arial, Helvetica, sans serif;
}

:link, :visited {
	color: #c00;
	text-decoration: none;
	border-bottom: 1px dotted #bbb;
}

:link:hover, :visited:hover {
	background-color: #eee;
	color: #555;
}

.content {
	width: 700px;
	max-width: 100%;
	margin: 5px;
}

fieldset {
	margin: 5px;
	color: #bbb;
	border: 1px solid #bbb;
	font-weight: bold;
}

fieldset ul li {
	color: #000;
	font-weight: normal;
}

/* links/anchors with images */
:link img, :visited img{
	color: #fff;
	background-color: #fff
	
	text-decoration: none;
	border: none;
	
	display: block;
}

:link:hover img, :visited:hover img{
	color: #09c;
	background-color: #09c
}

/* a div button */
.button {
	margin: 10px auto;
	background-color: #eee;
	border: 1px dotted #bbb;
	width: 100px;
	padding: 5px;
	text-align: center;
}

/* general menu */
.menu ul {
	margin: 0;
	font-size: 10px;
	text-align: right;
	
	list-style: none;
}

.menu li {
	display: inline;
	border-right: 1px solid #d7d7d7;
	padding: 0 .75em;
	white-space: nowrap;
}

/* login menu */
#login_menu {
	text-align: right;
	color: #bbb;
	margin: 5px;
	padding: 5px;
}

#login_menu .text {
	color: #000;
}

/* main menu */
#main_menu {
	margin: .66em 5px;
	padding: .2em 0;
	border: 1px solid #000;
	background-color: #f7f7f7;
}

#main_menu li {
	border-right: none;
	padding: .25em 0;
}

#main_menu :link, #main_menu :visited {
	color: #000;
	background-color: #fff;
	border-left: 1px solid #555;
	border-bottom: none;
	border-right: 1px solid #fff;
	padding: .2em 20px;
}

#main_menu :link:hover, #main_menu :visited:hover {
	background-color: #ccc;
	border-right: 1px solid #ddd;
}

#main_menu .active :link, #main_menu .active :visited {
	font-weight: bold;
	color: #eee;
	border-right: 1px solid #000;
	border-top: none;
	background-color: #333;
}

#main_menu .active :link:hover, #main_menu .active :visited:hover {
	border-right: 1px solid #000;
}

/* side menu (left) */
#tab_menu {
	border: 1px solid black;
	border-color: gray black black gray;
	margin: 2em 5px;
	padding: .5em 0 0;
	float: left;
	width: 12em;
}

#tab_menu ul { list-style: none; margin: 0 0 .5em; padding: 0 }
#tab_menu ul { list-style: none; margin: 0 0 .5em; padding: 0 }
#tab_menu li { margin: 0; padding: 0.1em .5em }
#tab_menu li li { margin: 0 -0.5em; padding-left: 1.5em }
#tab_menu li li.active { background: #ccb; }
#tab_menu :link, .tabs :visited { border: none; display: block }
#tab_menu :link:hover, .tabs :visited:hover { background: transparent }

.content_with_menu {
	padding: 0.4em 2em;
	margin-left: 12em;
	min-height: 300px;
	width: 400px;
	max-width: 100%
}

/* detailed view */
#issue {
 background: #ffd;
 border: 1px outset #996;
 margin-top: 1em;
 padding: .5em 1em;
 position: relative;
}

#issue h2 {
	margin: 0 0 .8em 0;
}

#issue table.details {
 border-top: 1px solid #dd9;
 border-collapse: collapse;
 table-layout: fixed;
 width: 100%;
}

#issue table.details tr { 
	border-bottom: 1px dotted #eed;
}

#issue table.details td, #issue table.details th {
 font-size: 80%;
 padding: .5em 1em;
 vertical-align: top;
}

#issue table.details th {
 color: #663;
 font-weight: normal;
 text-align: left;
 width: 20%;
}

#issue table.details td {
	width: 30%;
}

#issue table.details .description {
	border-top: 1px solid #dd9;
}

#issue .description h3 {
 border-bottom: 1px solid #dd9;
 color: #663;
 font-size: 100%;
 font-weight: normal;
}

.comment {
	background: #ffc;
	padding: 1em;
	border: 1px outset #996;
	margin-bottom: 1em;
}

.comment h3 {
 border-bottom: 1px solid #d7d7d7;
 color: #999;
 font-size: 100%;
 font-weight: normal;
}

/* drag & droppable lists */

fieldset.drag_list {
	float: left;
	width: 170px;
}

fieldset.drag_list ul {
	min-height: 50px;
	color: #000;
	
	list-style: none;
	padding: 0;
	margin: 0;
}

fieldset.drag_list ul li {
	margin: 4px;
	padding: 2px;
	cursor: move;
	font-weight: normal;
	text-align: center;
}

fieldset.drag_list ul li.attached {
	background-color: #6c6;
  	border: 1px solid #060;
}
fieldset.drag_list ul li.available {
	background-color: #ddd;
  	border: 1px dashed #000;
}

/*
#main_menu a.active {
	color: #fff;
	background-color: #000;
}

#main_menu a:hover {
	color: #fff;
	background-color: #000;
}
*/
/* a simple button */
/* a.button, a.button:hover {
	text-decoration: none;		
	color: #000
}
	
a.button:hover {
	color: #fff;
}
	
span.button, span.button:hover {
		margin: 5px;
		padding: 5px;
		font-size: 10px;
		font-family: Verdana,Arial;
		border-width: 1px;
		border-style: none, none, solid, none;
		border-color: #000;
		text-align: center;
		background-color: #fff;		
	}
	
div span.button:hover {
	background-color: #000;
}*/

/* older stuff */

	
	div.security_container {
		padding: 10px;
		border-width: 1px;
		border-style: solid;
		width: 500px;
	}
	
	div.security_menu {
		margin: 0px;
	}
	'! !

TestCase subclass: #ITTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

ITTest subclass: #ITTestGlorpDB
	instanceVariableNames: 'login accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestGlorpDB methodsFor: 'testing' stamp: 'afk 12/13/2007 14:52'!
setUp
	
	super setUp.
	login := ITGlorpDB login.
	accessor := DatabaseAccessor forLogin: login.! !

!ITTestGlorpDB methodsFor: 'testing' stamp: 'mt 12/14/2007 15:47'!
testConnect
	"Tests whether ITGlorpDB>>#connect answers with a valid GlorpSession which could be used for operating with the SQL database."
	
	| session |
	session := ITGlorpDB connect.
	
	self assert: (login username = session currentLogin username) description: 'Username of session does not equal login username'.
	self assert: (login connectString = session currentLogin connectString) description: 'ConnectString of session does not equal login ConnectString'.
	self assert: (login password = session currentLogin password) description: 'Password of session does not equal login password '.
	
	self assert: session isLoggedIn.! !

!ITTestGlorpDB methodsFor: 'testing' stamp: 'mt 12/14/2007 15:44'!
testLogin
	"Tests whether it is possible to use the default login for connecting to a vaild SQL database which is used in the whole application."
	
	self assert: accessor isLoggedIn not.
	accessor loginIfError: [:exception | self assert: false.].
	self assert: accessor isLoggedIn.
	accessor logout.
	self assert: accessor isLoggedIn not.! !

!ITTestGlorpDB methodsFor: 'testing' stamp: 'mig 12/20/2007 18:53'!
testUniqueSession
	"Tests whether a glorp session really is a singleton."


	self assert: ITGlorpSession getInstance notNil description: 'Glorp session is nil.'.
	self assert: (ITGlorpSession getInstance == ITGlorpSession getInstance) description: 'Glorp session is not unique.'.! !

ITTest subclass: #ITTestIssue
	instanceVariableNames: 'issue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestIssue methodsFor: 'testing' stamp: 'mt 12/30/2007 11:39'!
setUp

	super setUp.
	issue := ITIssue new.! !

!ITTestIssue methodsFor: 'testing' stamp: 'mt 1/6/2008 00:06'!
testAddComment
	
	|comment|
	comment := ITIssueComment with: 'TESTCOMMENT'.
	issue addComment: comment.
	
	self 
		assert: issue comments last content = 'TESTCOMMENT' 
		description: 'A just added comment could not be retrieved from the issue.'! !

!ITTestIssue methodsFor: 'testing' stamp: 'mt 12/14/2007 16:32'!
testComments
	"Tests whether the accessors for #comments do what they should do - set and get."
	
	| comments |
	comments := OrderedCollection new.
	issue comments: comments.
	
	self 
		assert: issue comments == comments 
		description: 'An ordered collection of comments was just set and could not be retrieved from the issue.'! !

!ITTestIssue methodsFor: 'testing' stamp: 'mt 12/14/2007 16:32'!
testDetails
	"Tests whether the accessors for #details do what they should do - set and get."
	
	| details |
	details := OrderedCollection new.
	issue details: details.
	
	self 
		assert: issue details == details 
		description: 'An ordered collection of details was just set and could not be retrieved from the issue.'! !

!ITTestIssue methodsFor: 'testing' stamp: 'mt 12/14/2007 16:32'!
testGetTag

	| detail |
	detail := ITIssueDetail new.
	detail tag: 'title'.
	detail content: 'TESTTITLE'.
	issue details: detail asOrderedCollection.
	
	self 
		assert: (issue getTag: 'title') = 'TESTTITLE' 
		description: 'A just added detail could not be retrieved from the issue.'! !

!ITTestIssue methodsFor: 'testing' stamp: 'mt 12/14/2007 16:30'!
testId
	"Tests whether the accessors for #id do what they should do - set and get."

	issue id: 1.
	
	self
		assert: issue id = 1 
		description: 'An id was just set and could not be retrieved from the issue.'! !

!ITTestIssue methodsFor: 'testing' stamp: 'mt 12/14/2007 16:31'!
testSetDetailWithTo
	
	issue setDetailWith: 'title' to: 'TESTTITLE'.
	
	self 
		assert: (issue getTag: 'title') = 'TESTTITLE' 
		description: 'A new detail was set and could not be retrieved from the issue.'! !

ITTest subclass: #ITTestIssueComment
	instanceVariableNames: 'comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestIssueComment methodsFor: 'testing' stamp: 'mt 12/30/2007 11:39'!
setUp

	super setUp.
	comment := ITIssueComment new.! !

!ITTestIssueComment methodsFor: 'testing' stamp: 'mt 12/14/2007 16:29'!
testContent
	"Tests whether the accessors for #content do what they should do - set and get."

	comment content: 'TESTCOMMENT'.
	
	self 
		assert: comment content = 'TESTCOMMENT' 
		description: 'A content was just set and could not be retrieved from the comment.'! !

!ITTestIssueComment methodsFor: 'testing' stamp: 'mt 12/14/2007 16:29'!
testId
	"Tests whether the accessors for #id do what they should do - set and get."

	comment id: 1.
	
	self 
		assert: comment id = 1 
		description: 'An id was just set and could not be retrieved from the comment.'! !

ITTest subclass: #ITTestIssueDetail
	instanceVariableNames: 'detail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestIssueDetail methodsFor: 'testing' stamp: 'mt 12/30/2007 11:39'!
setUp

	super setUp.
	detail := ITIssueDetail new.! !

!ITTestIssueDetail methodsFor: 'testing' stamp: 'mt 12/14/2007 16:28'!
testContent
	"Tests whether the accessors for #content do what they should do - set and get."

	detail content: 'TESTCONTENT'.
	
	self 
		assert: detail content = 'TESTCONTENT' 
		description: 'A content was just set and could not be retrieved from the detail.'! !

!ITTestIssueDetail methodsFor: 'testing' stamp: 'mt 12/14/2007 16:26'!
testId
	"Tests whether the accessors for #id do what they should do - set and get."

	detail id: 1.
	
	self 
		assert: detail id = 1 
		description: 'An id was just set and could not be retrieved from the detail.'! !

!ITTestIssueDetail methodsFor: 'testing' stamp: 'mt 12/14/2007 16:27'!
testTag
	"Tests whether the accessors for #tag do what they should do - set and get."

	detail tag: 'TESTTAG'.
	
	self 
		assert: detail tag = 'TESTTAG' 
		description: 'A tag was just set and could not be retrieved from the detail.'! !

ITTest subclass: #ITTestIssueManager
	instanceVariableNames: 'issueManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestIssueManager methodsFor: 'testing' stamp: 'mt 12/30/2007 11:39'!
setUp
	
	super setUp.
	issueManager := ITIssueManager new.! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mt 1/5/2008 10:37'!
testAddCommentAtID

	| issue |
	issue := issueManager addIssueWithTitle: 'tmp_testAddCommentAtID'.
	
	self flag: #TODO. "Handle ITUnauthorizedError!!"
	
	issueManager addComment: 'tmp_testAddCommentAtID_comment' atID: issue id.
	
	self 
		assert: (issueManager getIssueWithID: issue id) comments last content = 'tmp_testAddCommentAtID_comment'
		description: 'A comment to a new issue was just set and could not be retrieved through an issue manager.'.
	
	issueManager deleteIssueWithID: issue id.! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mt 1/5/2008 10:37'!
testAddIssueWithTitle
	
	| issue |
	issue := issueManager addIssueWithTitle: 'tmp_testAddIssueWithTitle'.
	
	self flag: #TODO. "Handle ITUnauthorizedError!!"
	
	self 
		assert: (issue isKindOf: ITIssue) 
		description: 'ITIssueManager>>#addIssueWithTitle: is not returning an object with type ITIssue'.
		
	self
		deny: (issue id) isNil
		description: 'ITIssueManager>>#addIssueWithTitle: returns an ITIssue object which has no ID.'.
		
	self
		assert: ((issueManager getIssueWithID: issue id) getTag: 'title') = 'tmp_testAddIssueWithTitle'
		description: 'A new issue with a title was just set and the title could not be retrieved through an issue manager.'.
	
	issueManager deleteIssueWithID: issue id.! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mt 1/5/2008 10:09'!
testAddIssueWithTitleWithComment

	| issue |
	issue := issueManager
		addIssueWithTitle: 'tmp_testAddIssueWithTitleWithComment'
		withComment: 'tmp_testAddIssueWithTitleWithComment_comment'.
		
	self flag: #TODO. "Handle ITUnauthorizedError!!"
	
	self 
		assert: (issue isKindOf: ITIssue) 
		description: 'ITIssueManager>>#addIssueWithTitle:WithComment: is not returning an object with type ITIssue'.
		
	self
		deny: (issue id) isNil
		description: 'ITIssueManager>>#addIssueWithTitle:WithComment: returns an ITIssue object which has no ID.'.
		
	self
		assert: ((issueManager getIssueWithID: issue id) getTag: 'title') = 'tmp_testAddIssueWithTitleWithComment'
		description: 'A new issue with a title and a comment was just set and the title could not be retrieved through an issue manager.'.
		
	self
		assert: ((issueManager getIssueWithID: issue id) comments last content) = 'tmp_testAddIssueWithTitleWithComment_comment'
		description: 'A new issue with a title and a comment was just set and the comment could not be retrieved through an issue manager.'.		
	
	issueManager deleteIssueWithID: issue id.
! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mt 1/5/2008 10:37'!
testDeleteIssueWithID

	| issue |
	
	issue := issueManager addIssueWithTitle: 'tmp_testDeleteIssueWithID'.
	
	self flag: #TODO. "Handle ITUnauthorizedError!!"
	
	issueManager deleteIssueWithID: issue id.
	
	self
		assert: (issueManager getIssueWithID: issue id) isNil
		description: 'A new issue was just added and could not be deleted through an issue manager.'
	

	! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mt 1/5/2008 10:38'!
testGetIssueWithID
	
	| issue |
	issue := issueManager addIssueWithTitle: 'tmp_testGetIssueWithID'.
	
	self flag: #TODO. "Handle ITUnauthorizedError!!"
	
	self
		assert: ((issueManager getIssueWithID: issue id) getTag: 'title') = 'tmp_testGetIssueWithID'
		description: 'A new issue was just added and could not be retrieved through an issue manager'.
		
	issueManager deleteIssueWithID: issue id.! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mt 1/5/2008 10:38'!
testGetIssues
	
	self flag: #TODO. "Handle ITUnauthorizedError!!"
	
	issueManager getIssues do: [ :issue |
		self 
			assert: (issue isKindOf: ITIssue)
			description: 'ITIssueManager>>#getIssues returns a collection in where not all objects are issues.'.
		
		self
			deny: (issue id) isNil
			description: 'ITIssueManager>>#getIssues returns a collection in where not all issues have an ID.'.
	].
	
	
	! !

ITTest subclass: #ITTestRole
	instanceVariableNames: 'role'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:39'!
setUp

	super setUp.
	role := ITRole new! !

!ITTestRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:20'!
testAddPrivilege
	"Tests whether it is possible to add a privilege but not twice the same one."
	
	2 timesRepeat: [role addPrivilege: 'write'].

	self
		assert: role privileges size = 1
		description: 'A privilege was added twice to a role.'! !

!ITTestRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:27'!
testHasPrivilege
	"Tests whether it is possible to add a privilege to a role and ask this role whether it has this privilege."
	
	role addPrivilege: 'write'.
		
	self
		assert: (role hasPrivilege: 'write')
		description: 'A privilege was just added and could not be retrieved from a role.'! !

!ITTestRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:18'!
testId
	"Tests whether the accessors for #id do what they should do - set and get."

	role id: 1.
	
	self
		assert: role id = 1 
		description: 'An id was just set and could not be retrieved from the role.'! !

!ITTestRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:23'!
testPrivileges
	"Tests whether the accessors for #privileges do what they should do - set and get."

	| somePrivileges |
	somePrivileges := #('read' 'read' 'write' 'write').
	role privileges: somePrivileges.
	
	self
		assert: (role privileges isKindOf: Set) 
		description: 'The privileges of a role are not a set.'.
		
	self
		assert: role privileges = #('read' 'write') asSet
		description: 'Some privileges where just set to a role and could not be retrieved.' ! !

!ITTestRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:28'!
testRemovePrivilege
	"Tests whether it is possible to remove a privilege from a role."
	
	role
		addPrivilege: 'write';
		removePrivilege: 'write'.

	self
		assert: role privileges size = 0
		description: 'A privilege was added and could not be removed from a role.'! !

!ITTestRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:15'!
testRolename
	"Tests whether the accessors for #rolename do what they should do - set and get."

	role rolename: 'testrole'.
	
	self
		assert: role rolename = 'testrole'
		description: 'A rolename was just set and could not be retrieved from the role.'! !

ITTest subclass: #ITTestSecurityManager
	instanceVariableNames: 'securityManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 11:58'!
setUp

	super setUp.
	securityManager := ITSecurityManager new.! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 12:48'!
testAddRole
	"Tests whether it is possible to add a new role to the database."
	
	|role|
	role := ITRole new.
	role rolename: 'tmp_testAddRole'.
	
	securityManager addRole: role.
	
	self
		deny: role id isNil 
		description: 'New role could not be added to database through security manager because it got no ID.'.
		
	securityManager deleteRoleWithID: role id.! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 13:09'!
testAddUser
	"Tests whether it is possible to add a new user to the database."
	
	|user|
	user := ITUser new.
	user username: 'tmp_testAddUser'.
	
	securityManager addUser: user.
	
	self
		deny: user id isNil 
		description: 'New user could not be added to database through security manager because it got no ID.'.
		
	securityManager deleteUserWithID: user id.! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 12:56'!
testDeleteRoleWithID
	"Tests whether it is possible to remove a role with a given ID from the database."
	
	|role|
	role := ITRole new.
	role rolename: 'tmp_testDeleteRoleWithID'.
	securityManager 
		addRole: role;
		deleteRoleWithID: role id.
		
	self
		assert: (securityManager getRoleWithID: role id) isNil
		description: 'A role could not be deleted through a security manager.'
	! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 13:10'!
testDeleteUserWithID
	"Tests whether it is possible to remove a user with a given ID from the database."
	
	|user|
	user := ITUser new.
	user username: 'tmp_testDeleteUserWithID'.
	securityManager 
		addUser: user;
		deleteUserWithID: user id.
		
	self
		assert: (securityManager getUserWithID: user id) isNil
		description: 'A user could not be deleted through a security manager.'
	! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 13:40'!
testGetRole
	"Tests whether it is possible to retrieve a role instance with a given rolename from the database."
	
	|role|
	role := ITRole new.
	role rolename: 'tmp_testGetRoleWithID'.
	securityManager addRole: role.
	
	self
		assert: ((securityManager getRole: role rolename) isKindOf: ITRole)
		description: 'A new role was just added to the database through a security manager and could not be retrieved by its name.'.
	
	securityManager deleteRoleWithID: role id.! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 12:53'!
testGetRoleWithID
	"Tests whether it is possible to retrieve a role instance with a given ID from the database."
	
	|role|
	role := ITRole new.
	role rolename: 'tmp_testGetRoleWithID'.
	securityManager addRole: role.
	
	self
		assert: (securityManager getRoleWithID: role id) rolename = 'tmp_testGetRoleWithID'
		description: 'A new role was just added to the database through a security manager and could not be retrieved.'.
	
	securityManager deleteRoleWithID: role id.! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 13:40'!
testGetUser
	"Tests whether it is possible to retrieve a user instance with a given username from the database."
	
	|user|
	user := ITUser new.
	user username: 'tmp_testGetUser'.
	securityManager addUser: user.
	
	self
		assert: ((securityManager getUser: user username) isKindOf: ITUser)
		description: 'A new user was just added to the database through a security manager and could not be retrieved by its name.'.
	
	securityManager deleteUserWithID: user id.! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 13:41'!
testGetUserWithID
	"Tests whether it is possible to retrieve a user instance with a given ID from the database."
	
	|user|
	user := ITUser new.
	user username: 'tmp_testGetUserWithID'.
	securityManager addUser: user.
	
	self
		assert: (securityManager getUserWithID: user id) username = 'tmp_testGetUserWithID'
		description: 'A new user was just added to the database through a security manager and could not be retrieved.'.
	
	securityManager deleteUserWithID: user id.! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 13:46'!
testHashAlgorithm
	"Tests whether Message Digest 5 Hash is used by the security manager."
	
	self
		assert: ITSecurityManager hashAlgorithm == MD5
		description: 'ITSecurityManager uses wrong hash algorithm. MD5 expected.'! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 13:50'!
testHashPassword
	"Tests whether a given password will be modified correctly through the security manager."
	
	self
		deny: (ITSecurityManager hashPassword: 'somepassword') = 'somepassword'
		description: 'A password was not hashed through security manager. The plain text was returned.'.
		
	self
		assert: (ITSecurityManager hashPassword: 'somepassword') = (ITSecurityManager hashPassword: 'somepassword')
		description: 'The security manager returns different hashes for the same plain text.'! !

!ITTestSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 14:04'!
testValidatePasswordFor
	"Tests whether security manager verifies the password for a user correctly."
	
	|user plaintext|
	plaintext := 'tmp_testValidatePasswordFor'.
	user := ITUser new.
	user username: 'tmp_testValidatePasswordFor_username'.
	user setPassword: plaintext.
	
	securityManager addUser: user.
	
	self
		assert: (securityManager validatePassword: plaintext for: user username)
		description: 'A correct password for a user could not be validated through the security manager.'.
		
	self
		deny: (securityManager validatePassword: (plaintext,'invalid_garbage') for: user username)
		description: 'An invalid password for a user was validated through the security manager. False expected.'.
		
	securityManager deleteUserWithID: user id.
! !

ITTest subclass: #ITTestSession
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestSession methodsFor: 'testing' stamp: 'mt 12/30/2007 11:53'!
setUp

	super setUp.
	session := ITSession new.! !

!ITTestSession methodsFor: 'testing' stamp: 'mt 12/30/2007 11:41'!
testIssueManager
	"Tests whether there is only one issue manager per session."
	
	self
		assert: session issueManager == session issueManager
		description: 'An ITSession instance returns different ITIssueManager instances. There should only be one.'! !

!ITTestSession methodsFor: 'testing' stamp: 'mt 12/30/2007 11:44'!
testLanguage
	"Tests whether it is possible to set and get a language for translation issues."
	
	session language: #english.
	
	self
		assert: session language = #english
		description: 'A language was just set and could not be retrieved from a session.'! !

!ITTestSession methodsFor: 'testing' stamp: 'mt 12/30/2007 11:42'!
testSecurityManager
	"Tests whether there is only one security manager per session."
	
	self
		assert: session securityManager == session securityManager
		description: 'An ITSession instance returns different ITSecurityManager instances. There should only be one.'! !

!ITTestSession methodsFor: 'testing' stamp: 'mt 12/30/2007 11:52'!
testUser
	"Tests whether it is possible to set and get a user for a session."
	
	| user |
	user := ITUser new.
	
	session user: user.
	
	self
		assert: session user == user
		description: 'A user was just set and could not be retrieved from a session.'! !

ITTest subclass: #ITTestTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestTranslator methodsFor: 'testing' stamp: 'mt 12/26/2007 12:16'!
testDiscardTranslationsForLanguage
	"Tests whether all translations for a given language will be discarded."

	(ITTranslator getInstance loadTranslationFile: 'example.ts' forLanguage: #example).
	
	self
		assert: (ITTranslator getInstance translate: 'test' into: #example) = 'test'
		description: 'The test string should not be translated but was modified.'! !

!ITTestTranslator methodsFor: 'testing' stamp: 'mt 12/26/2007 12:14'!
testLoadTranslationFileForLanguage
	"Tests whether it is possible to load a translation file (a lookup dictionary or so)."
	
	(ITTranslator getInstance loadTranslationFile: 'example.ts' forLanguage: #example).
	
	self
		assert: (ITTranslator getInstance translate: 'test' into: #example) = 'test_translated'
		description: 'Could not translate test string.'! !

!ITTestTranslator methodsFor: 'testing' stamp: 'mt 12/26/2007 11:09'!
testSingleton
	"Tests whether ITTranslator is a singleton."
	
	self
		assert: ITTranslator getInstance == ITTranslator getInstance
		description: ITTranslator name, '(class)>>#getInstance returns variing objects. Should be a Singleton.'.
		
	[ITTranslator new]
		on: Exception
		do: [^self].
		
	self
		assert: false
		description: ITTranslator name, '(class)>>#new does not throws an Exception!! Should be a Singleton.'! !

!ITTestTranslator methodsFor: 'testing' stamp: 'mt 12/26/2007 12:00'!
testTr
	"Tests whether ByteString>>#tr does return a byte string as well."
	
	self
		assert: ('test' tr isKindOf: ByteString)
		description: 'ByteString>>#tr does not return an instance of ByteString.'! !

!ITTestTranslator methodsFor: 'testing' stamp: 'mt 12/26/2007 12:15'!
testTranslateInto
	"Tests whether the same text is returned if no translation is used."
	
	self
		assert: (ITTranslator getInstance translate: 'No Translation' into: #default) = 'No Translation'
		description: 'Text was modified while no translation was performed!!'! !

ITTest subclass: #ITTestUser
	instanceVariableNames: 'user adminRole guestRole'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 11:40'!
setUp

	super setUp.
	user := ITUser new.
	
	adminRole := ITRole new.
	adminRole rolename: 'admin'.
	
	guestRole := ITRole new.
	guestRole rolename: 'guest'.! !

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 10:59'!
testAddRole
	"Tests whether it is possible to add a role but not twice the same role."
	
	2 timesRepeat: [user addRole: guestRole].

	self
		assert: user roles size = 1
		description: 'A role was added twice to a user.'! !

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 10:36'!
testId
	"Tests whether the accessors for #id do what they should do - set and get."

	user id: 1.
	
	self
		assert: user id = 1 
		description: 'An id was just set and could not be retrieved from the user.'! !

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 11:00'!
testIsInRole
	"Tests whether it is possible to add a role to a user and ask this user whether he is in that role."
	
	user addRole: adminRole.
		
	self
		assert: (user isInRole: adminRole)
		description: 'A role was just added and could not be retrieved from a user.'! !

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 10:41'!
testPassword
	"Tests whether a password for a user can be set and retrieved as hash for security reasons."

	|password hash|
	password :=	'justsomestupidpasswordwhichwillneverbeinplaintextagain'.
	hash := ITSecurityManager hashPassword: password.
	
	user setPassword: password.
	
	self
		assert: user passwordHash = hash
		description: 'The user got another password hash as from ITSecurityManager(class)>>#hashPassword:.'
! !

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 11:00'!
testRemoveRole
	"Tests whether it is possible to remove a role."
	
	user
		addRole: adminRole;
		removeRole: adminRole.

	self
		assert: user roles size = 0
		description: 'A role was added and could not be removed from a user'! !

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 11:22'!
testRoles
	"Tests whether the accessors for #roles do what they should do - set and get."

	| someRoles |
	someRoles := {adminRole. adminRole. guestRole. guestRole}.
	user roles: someRoles.
	
	self
		assert: (user roles isKindOf: Set) 
		description: 'The roles of an user are not a set.'.
		
	self
		assert: user roles = {adminRole. guestRole} asSet
		description: 'Some roles where just set to a user and could not be retrieved.' ! !

!ITTestUser methodsFor: 'testing' stamp: 'mt 12/30/2007 10:37'!
testUsername
	"Tests whether the accessors for #username do what they should do - set and get."

	user username: 'testuser'.
	
	self
		assert: user username = 'testuser' 
		description: 'A username was just set and could not be retrieved from the user.'! !

Object subclass: #ITGlorpDB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITGlorpDB commentStamp: 'mt 12/14/2007 10:22' prior: 0!
I encapsulate the connection to a SQL database, at the moment with PostGreSQL. Feel free to use my class side method #connect to get a new ITGlorpSession instance. But be aware of the connection. You'll have to check whether ITGlorpSession>>#isLoggedIn.!

!ITGlorpDB class methodsFor: 'debug' stamp: 'mt 12/14/2007 10:37'!
closeAllConnections
	ITGlorpSession allInstances do: [:aSession |
		aSession logout.
		Transcript show: 'DEBUG: You closed a Session.']! !

!ITGlorpDB class methodsFor: 'connection' stamp: 'mt 12/15/2007 12:30'!
connect
	"Connects to the database with the given information from login and returns the current (new) session."	
	
	| accessor session system |
	accessor := DatabaseAccessor forLogin: self login.
	accessor login.

	session := GlorpSession new.
	session accessor: accessor.

	system := ITGlorpDescriptorSystem new.
	session system: system.
	system platform: session platform.
	
	^ session
! !

!ITGlorpDB class methodsFor: 'debug' stamp: 'mig 12/16/2007 16:35'!
createTables
	"I'm creating alle relevant tables but only if there are none of them."
	
	| session |
	Transcript show: 'DEBUG: You try to create all tables again.'.
	session := ITGlorpDB connect.
	session inTransactionDo: [session system allTables do: [:each |
			Transcript cr; show: each name; cr.
			session accessor createTable: each ifError: [:error | Transcript show: error messageText]
		]
	].

	session inTransactionDo: [session system allTables do: [:each |
	session accessor createTableFKConstraints: each ifError: [:error | Transcript show: error messageText]		
		]
	].! !

!ITGlorpDB class methodsFor: 'connection' stamp: 'mt 1/6/2008 00:07'!
login
	"The default login can be found here. It is used across the whole issue tracker application. It is also used for unit tests."
	
	^ Login new database: PostgreSQLPlatform new;
		username: 'issuetracker';
		password: 'weloveseasidedontwe';
		connectString: 'theresnoplacelike.homeftp.org:5432_issuetracker'.
		
	"^ Login new database: PostgreSQLPlatform new;
		username: 'postgres';
		password: '1234';
		connectString: 'localhost:5432_postgres'."! !

Object subclass: #ITIssue
	instanceVariableNames: 'id details comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssue commentStamp: 'mt 12/30/2007 14:33' prior: 0!
I am an issue, a task, a ticket ... or however you'll call me.

I encapsulate several details and comments.!

!ITIssue class methodsFor: 'instance creation' stamp: 'afk 12/13/2007 20:12'!
with: aTitle with: aComment

	| newIssue comment |
	newIssue := self new.
	comment := ITIssueComment new.
	
	comment content: aComment.
	
	newIssue comments add: comment.
	newIssue details add: (ITIssueDetail with: 'title' with: aTitle).

	^ newIssue! !

!ITIssue methodsFor: 'changing' stamp: 'mt 1/5/2008 11:23'!
addComment: aComment

	self comments add: aComment."(ITIssueComment with: aString)."! !

!ITIssue methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:55'!
comments
	^comments.! !

!ITIssue methodsFor: 'accessing' stamp: 'mt 12/11/2007 15:23'!
comments: aCollection
	comments := aCollection.! !

!ITIssue methodsFor: 'accessing' stamp: 'afk 12/13/2007 17:03'!
details
	^ details! !

!ITIssue methodsFor: 'accessing' stamp: 'afk 12/13/2007 17:03'!
details: anObject
	details := anObject! !

!ITIssue methodsFor: 'accessing' stamp: 'afk 12/13/2007 18:18'!
getTag: tag
	details do: 
		[:each | 
		each tag = tag
			ifTrue: [^ each content]
		].
	^nil.! !

!ITIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 16:20'!
id
	^ id! !

!ITIssue methodsFor: 'changing' stamp: 'afk 11/12/2007 16:20'!
id: anObject
	id := anObject! !

!ITIssue methodsFor: 'initialize-release' stamp: 'mt 12/15/2007 16:20'!
initialize

	super initialize.
	details := OrderedCollection new.
	comments := OrderedCollection new.

	! !

!ITIssue methodsFor: 'changing' stamp: 'mt 12/15/2007 16:20'!
setDetailWith: aTag to: aValue
	self details add: (ITIssueDetail with: aTag with: aValue)! !

Object subclass: #ITIssueComment
	instanceVariableNames: 'id content user timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssueComment commentStamp: 'mt 12/30/2007 14:30' prior: 0!
I am just an annotation to an issue.

You should be able to see which user created me, what's the content and when that user created me.!

!ITIssueComment class methodsFor: 'instance creation' stamp: 'mt 1/5/2008 11:35'!
with: aString
	^ self new
		content: aString;
		yourself.! !

!ITIssueComment class methodsFor: 'instance creation' stamp: 'mt 1/5/2008 11:37'!
with: aString by: aUser
	^ self new
		content: aString;
		user: aUser;
		timestamp: TimeStamp current;
		yourself.! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 17:18'!
content
	^ content! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 17:18'!
content: anObject
	content := anObject! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 17:18'!
id
	^ id! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 17:18'!
id: anObject
	id := anObject! !

!ITIssueComment methodsFor: 'initialize-release' stamp: 'mt 12/14/2007 10:02'!
initialize
	
	super initialize.
	
	content := ''.! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mt 1/5/2008 10:53'!
timestamp
	^ timestamp! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mt 1/5/2008 10:53'!
timestamp: anObject
	timestamp := anObject! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mt 1/5/2008 10:56'!
user
	^ user! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mt 1/5/2008 10:56'!
user: anObject
	user := anObject! !

Object subclass: #ITIssueDetail
	instanceVariableNames: 'id tag content user timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssueDetail commentStamp: 'mt 12/30/2007 14:28' prior: 0!
I represent an issue detail.

What's a detail? Well... it's a tag-value-combination. You have some tag like 'title' and the proper value like 'This is the title'. These two things form a 'detail'. There are other well-definied tags out there but you should be able to create your own one in the application (e.g. as an administrator).!

!ITIssueDetail class methodsFor: 'instance creation' stamp: 'mig 12/20/2007 18:51'!
with: aTag with: aValue
	
	| detail |
	detail := self new.
	detail tag: aTag.
	detail content: aValue.
	
	^ detail.! !

!ITIssueDetail methodsFor: 'accessing' stamp: 'afk 12/13/2007 16:54'!
content
	^ content! !

!ITIssueDetail methodsFor: 'accessing' stamp: 'afk 12/13/2007 16:54'!
content: anObject
	content := anObject! !

!ITIssueDetail methodsFor: 'accessing' stamp: 'afk 12/13/2007 16:52'!
id
	^ id! !

!ITIssueDetail methodsFor: 'accessing' stamp: 'afk 12/13/2007 16:52'!
id: anObject
	id := anObject! !

!ITIssueDetail methodsFor: 'accessing' stamp: 'afk 12/13/2007 16:52'!
tag
	^ tag! !

!ITIssueDetail methodsFor: 'accessing' stamp: 'afk 12/13/2007 16:52'!
tag: anObject
	tag := anObject! !

Object subclass: #ITIssueManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssueManager commentStamp: 'mt 12/30/2007 14:22' prior: 0!
I am responsible for any "issue-related" operations.

Every issue operation has to go through my methods. I determine which privilege is needed to perfom several actions. 

DO NOT talk to the ITSecurityManager about security-related things assigned to issues in any ITComponent - I will do that for you.!

!ITIssueManager methodsFor: 'accessing' stamp: 'mt 12/15/2007 12:34'!
addComment: aString atID: aNumber
	"Adds a new ITIssueComment object with the content 'aString' to the issue with the ID 'aNumber'."

	| issue glorpSession |
	glorpSession := ITGlorpSession getInstance.
	issue := glorpSession readOneOf: ITIssue where: [:each | each id = aNumber].
	
	glorpSession inUnitOfWorkDo: [
		glorpSession register: issue.
		issue addComment: aString.
	].! !

!ITIssueManager methodsFor: 'accessing' stamp: 'mt 1/5/2008 11:41'!
addComment: aString atID: aNumber by: aUser
	"Adds a new ITIssueComment object to the issue with the ID 'aNumber'."

	| issue glorpSession comment |
	glorpSession := ITGlorpSession getInstance.
	issue := glorpSession readOneOf: ITIssue where: [:each | each id = aNumber].

	comment := ITIssueComment with: aString by: aUser.
	
	glorpSession inUnitOfWorkDo: [
		glorpSession register: issue.
		glorpSession register: comment.
		issue addComment: comment.
	].! !

!ITIssueManager methodsFor: 'changing' stamp: 'mt 1/5/2008 10:27'!
addIssueWithTitle: aString
	"Adds a new issue with a detail 'title' to the database. Returns this new issue."
	
	| session issue |
	
	ITSecurityManager checkPrivilege: 'add_issue'.
	
	session := ITGlorpSession getInstance.
	
	issue := ITIssue new.
	issue setDetailWith: 'title' to: aString.
	
	session inUnitOfWorkDo: [
		session register: issue.
	].

	^issue.! !

!ITIssueManager methodsFor: 'changing' stamp: 'mt 1/5/2008 09:53'!
addIssueWithTitle: aTitleString withComment: aCommentString
	"Adds a new issue with a title and an initial comment to the database. Returns this new issue."
	
	| session issue |
	
	ITSecurityManager checkPrivilege: 'add_issue'.
	
	session := ITGlorpSession getInstance.
	issue := ITIssue with: aTitleString with: aCommentString.
	
	session inUnitOfWorkDo: [
		session register: issue.
	].
	
	^issue.! !

!ITIssueManager methodsFor: 'accessing' stamp: 'mt 1/5/2008 10:26'!
deleteIssueWithID: aNumber
	"Tries to delete an issue with the given ID from the database."
	
	| session issue |
	
	ITSecurityManager checkPrivilege: 'delete_issue'.
	
	session := ITGlorpSession getInstance.
	
	issue := session readOneOf: ITIssue where: [:each | each id = aNumber].
	
	session delete: issue.
	! !

!ITIssueManager methodsFor: 'accessing' stamp: 'mt 1/5/2008 10:26'!
getIssueWithID: aNumber
	"Returns an ITIssue object where the 'id' equals 'aNumber'."
	| glorpSession |
	
	ITSecurityManager checkPrivilege: 'read_issue'.

	glorpSession := ITGlorpSession getInstance.
	^ glorpSession readOneOf: ITIssue where: [:each | each id = aNumber].
! !

!ITIssueManager methodsFor: 'accessing' stamp: 'mt 1/5/2008 10:26'!
getIssues
	"Returns all ITIssue objects in a collection that are in the database"
	
	ITSecurityManager checkPrivilege: 'list_issues'.

	^ ITGlorpSession getInstance readManyOf: ITIssue.
	! !

Object subclass: #ITRole
	instanceVariableNames: 'id rolename privileges users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITRole commentStamp: 'mt 12/30/2007 14:37' prior: 0!
I am a user role and encapsulate a group of privileges.!

!ITRole methodsFor: 'accessing' stamp: 'mig 12/17/2007 15:07'!
addPrivilege: aSymbol
	privileges add: aSymbol asString! !

!ITRole methodsFor: 'testing' stamp: 'mt 12/30/2007 11:24'!
hasPrivilege: aSymbol
	^ privileges includes: aSymbol! !

!ITRole methodsFor: 'accessing' stamp: 'mig 12/16/2007 16:23'!
id
	^ id! !

!ITRole methodsFor: 'accessing' stamp: 'mig 12/16/2007 16:23'!
id: anObject
	id := anObject! !

!ITRole methodsFor: 'initialization' stamp: 'mt 1/5/2008 23:31'!
initialize
	super initialize.
	
	privileges := Set new.
	users := Set new.
	rolename := 'unnamed'.! !

!ITRole methodsFor: 'accessing' stamp: 'mig 12/16/2007 16:49'!
privileges
	^ privileges! !

!ITRole methodsFor: 'accessing' stamp: 'mt 12/30/2007 11:24'!
privileges: somePrivileges
	"Ensure that privileges are a set."
	
	privileges := somePrivileges asSet! !

!ITRole methodsFor: 'accessing' stamp: 'mig 12/17/2007 15:09'!
removePrivilege: aSymbol
	privileges remove: aSymbol asString.! !

!ITRole methodsFor: 'accessing' stamp: 'mig 12/16/2007 15:53'!
rolename
	^ rolename! !

!ITRole methodsFor: 'accessing' stamp: 'mig 12/16/2007 15:53'!
rolename: anObject
	rolename := anObject! !

!ITRole methodsFor: 'accessing' stamp: 'mt 1/5/2008 23:27'!
users
	^ users! !

!ITRole methodsFor: 'accessing' stamp: 'mt 1/5/2008 23:27'!
users: anObject
	users := anObject! !

Object subclass: #ITSecurityManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITSecurityManager commentStamp: 'mt 12/30/2007 14:23' prior: 0!
I am responsible for application security operations.

You ask me to add and retrieve users and roles from/to the database. I'm able to hash a password which is in plaintext - that is more secure than saving them without.

Please DO NOT let me add any issue related stuff to the database - that's the job of the ITIssueManager. Although I'm able to verify passwords to usernames and given privileges for a user, it's also the job of the ITIssueManager to assign safety critical operations on issues to needed privileges.!

!ITSecurityManager class methodsFor: 'testing' stamp: 'mig 12/22/2007 17:00'!
checkPrivilege: aSymbol 
	| currentSession |
	
	currentSession := WACurrentSession value.
	
	(currentSession securityManager hasUser: currentSession user privilege: aSymbol) ifFalse: [
		ITUnauthorizedError signal.
	].

	^ true.! !

!ITSecurityManager class methodsFor: 'hashing' stamp: 'mig 12/22/2007 17:13'!
hashAlgorithm
	^MD5! !

!ITSecurityManager class methodsFor: 'hashing' stamp: 'mig 12/22/2007 17:13'!
hashPassword: aString
	^ (self hashAlgorithm hashMessage: aString) hex.
	! !

!ITSecurityManager class methodsFor: 'hashing' stamp: 'mig 12/22/2007 17:15'!
hashSize
	"hash size is algorithms size * 2 because hashs are stored as hex"
	^ self hashAlgorithm hashSize * 2
	! !

!ITSecurityManager class methodsFor: 'testing' stamp: 'mt 1/5/2008 10:26'!
privileges
	"Returns all available privileges that are used by the issue manager or the security manager. Please note that privileges that are not listed here cannot be attached to a role with the web frontend."

	^#(read_issue add_issue delete_issue list_issues)! !

!ITSecurityManager methodsFor: 'traits' stamp: 'mig 12/22/2007 17:22'!
addRole: aRole
	"add an ITRole object to the database"
	| session |
	
	session := ITGlorpSession getInstance.
	
	session inUnitOfWorkDo: [
		session register: aRole.
	].! !

!ITSecurityManager methodsFor: 'traits' stamp: 'mig 12/22/2007 17:22'!
addUser: aUser
	"add an ITUser object to the database"
	| session |
	
	session := ITGlorpSession getInstance.
	
	session inUnitOfWorkDo: [
		session register: aUser.
	].! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mt 1/5/2008 23:47'!
deleteRoleWithID: aNumber
	"Removes a role with the given ID from the database."
	
	|session role|
	session := ITGlorpSession getInstance.
	
	role := session readOneOf: ITRole where: [:each | each id = aNumber].
	
	session delete: role.! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2007 12:10'!
deleteUserWithID: aNumber
	"Removes a user with the given ID from the database."
	
	|session user|
	session := ITGlorpSession getInstance.
	
	user := session readOneOf: ITUser where: [:each | each id = aNumber].
	
	session delete: user.! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mig 12/22/2007 17:22'!
getRole: aString
	"get ITRole object from database"
	| session |
	
	session := ITGlorpSession getInstance.
	^session readOneOf: ITRole where: [:each | each rolename = aString].
	! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2007 12:13'!
getRoleWithID: aNumber
	"get ITRole object with the given ID from database"
	
	| session |
	session := ITGlorpSession getInstance.
	^session readOneOf: ITRole where: [:each | each id = aNumber]
	! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mig 12/22/2007 17:21'!
getUser: aString
	"get ITUser object from database"
	| session |
	
	session := ITGlorpSession getInstance.
	^session readOneOf: ITUser where: [:each | each username = aString].
	! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2007 12:12'!
getUserWithID: aNumber
	"get ITUser object with the given ID from database"
	
	| session |
	session := ITGlorpSession getInstance.
	^session readOneOf: ITUser where: [:each | each id = aNumber]
	! !

!ITSecurityManager methodsFor: 'testing' stamp: 'mt 12/30/2007 13:53'!
hasUser: aUser privilege: aSymbol
	"Checks whether aUser has the aSymbol privilege. Verify aUser first."
	| user |
	
	user := self userOrDefaultUser: aUser.
	
	user roles do: [:role |
		(role hasPrivilege: aSymbol) ifTrue: [^true].
	].

	^false.! !

!ITSecurityManager methodsFor: 'initialization' stamp: 'mt 1/5/2008 10:23'!
initialize
	"Creates a default user if there is no one."
	
	super initialize.
	(self getUser: '*DEFAULT') isNil
		ifTrue: [|default| default := ITUser new. default username: '*DEFAULT'. self addUser: default]! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mig 12/22/2007 17:20'!
userOrDefaultUser: aUser
	"return aUser if not nil, return the default user if nil"
	
	^aUser ifNil: [self getUser: '*DEFAULT']! !

!ITSecurityManager methodsFor: 'as yet unclassified' stamp: 'mig 12/22/2007 17:21'!
validatePassword: aPassword for: aUsername
	"return whether aUsername and aPassword match"
	| user pwhash |
	
	user := self getUser: aUsername.
	pwhash := self class hashPassword: aPassword.
	
	user ifNil: [^false].
	^ user passwordHash = pwhash.! !

Object subclass: #ITTranslator
	instanceVariableNames: 'phraseBooks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

ITTranslator class
	instanceVariableNames: 'instance'!

!ITTranslator commentStamp: 'mt 12/26/2007 10:42' prior: 0!
I am responsible for managing all localization/internationalization issues in this application. You have to load a valid translation file and then any ByteString can be translated using ByteString>>#tr.!

ITTranslator class
	instanceVariableNames: 'instance'!

!ITTranslator class methodsFor: 'accesssing' stamp: 'mt 12/26/2007 10:53'!
getInstance
	"Using singleton pattern to ensure that there is only one instance of ITTranslator"
	
	instance ifNil:
		[ instance := self basicNew.].
	^ instance! !

!ITTranslator class methodsFor: 'instance creation' stamp: 'mt 12/26/2007 10:50'!
new
	Error signal: 'Use getInstance because ', self name, ' is a singleton'.! !

!ITTranslator methodsFor: 'translation' stamp: 'mt 12/26/2007 12:19'!
discardTranslationsForLanguage: aSymbol
	"Discards the given phrase book."
	
	phraseBooks
		removeKey: aSymbol
		ifAbsent: ["No such phrase book found."].! !

!ITTranslator methodsFor: 'initialization' stamp: 'mt 12/26/2007 11:49'!
initialize
	super initialize.
	
	phraseBooks := Dictionary new.! !

!ITTranslator methodsFor: 'translation' stamp: 'mt 12/26/2007 12:12'!
loadTranslationFile: aFilePath forLanguage: aSymbol
	"Creats a new phrase book for lookup."
	
	self flag: #TODO
! !

!ITTranslator methodsFor: 'private' stamp: 'mt 12/26/2007 11:50'!
phraseBookFor: aLanguage
	^phraseBooks at: aLanguage.! !

!ITTranslator methodsFor: 'translation' stamp: 'mt 12/26/2007 12:23'!
translate: aByteString into: aLanguage

	|phraseBook translation|	
	[phraseBook := self phraseBookFor: aLanguage]
		on: Error "key not found"
		do: [translation := aByteString].
	
	[translation := phraseBook at: aByteString]
		on: Error "key not found or invalid phrase book"
		do: [translation := aByteString].
	
	^translation.! !

Object subclass: #ITUser
	instanceVariableNames: 'id username passwordHash roles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITUser commentStamp: 'mt 12/30/2007 14:36' prior: 0!
I represent a user which is utilizing this application.

I have a username, a password and several roles that are attached to me. These roles enable me to do some operations through the ITIssueManager on the database.!

!ITUser methodsFor: 'accessing' stamp: 'mig 12/17/2007 15:00'!
addRole: aRole
	roles add: aRole.! !

!ITUser methodsFor: 'accessing' stamp: 'mig 12/16/2007 16:26'!
id
	^ id! !

!ITUser methodsFor: 'accessing' stamp: 'mig 12/16/2007 16:26'!
id: anObject
	id := anObject! !

!ITUser methodsFor: 'initialization' stamp: 'mt 12/29/2007 09:49'!
initialize
	super initialize.
	
	roles := Set new.! !

!ITUser methodsFor: 'testing' stamp: 'mt 12/30/2007 11:08'!
isInRole: aRole
	^roles includes: aRole! !

!ITUser methodsFor: 'accessing' stamp: 'mig 12/10/2007 17:27'!
passwordHash
	^ passwordHash! !

!ITUser methodsFor: 'accessing' stamp: 'mig 12/17/2007 15:10'!
removeRole: aRole
	roles remove: aRole.! !

!ITUser methodsFor: 'accessing' stamp: 'mig 12/10/2007 17:27'!
roles
	^ roles! !

!ITUser methodsFor: 'accessing' stamp: 'mt 12/30/2007 11:21'!
roles: someRoles
	"Ensure that roles are a set."

	roles := someRoles asSet! !

!ITUser methodsFor: 'passwords' stamp: 'mig 12/17/2007 13:36'!
setPassword: aString
	passwordHash := ITSecurityManager hashPassword: aString.! !

!ITUser methodsFor: 'accessing' stamp: 'mig 12/10/2007 17:27'!
username
	^ username! !

!ITUser methodsFor: 'accessing' stamp: 'mig 12/10/2007 17:27'!
username: anObject
	username := anObject! !

WASession subclass: #ITSession
	instanceVariableNames: 'issueManager language securityManager user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITSession commentStamp: 'mt 12/30/2007 14:42' prior: 0!
I am a normal Seaside session. You can get to your personal security manager and issue manager through my methods.

I have exactly one current language and one active user.!

!ITSession methodsFor: 'as yet unclassified' stamp: 'mt 1/5/2008 11:56'!
isLoggedIn
	"A default user is NOT logged in."	

	^(self user username = '*DEFAULT') not! !

!ITSession methodsFor: 'accessing' stamp: 'mig 12/30/2007 15:49'!
issueManager
	^ issueManager ifNil: [ issueManager := ITIssueManager new ].
! !

!ITSession methodsFor: 'accessing' stamp: 'mt 12/26/2007 11:36'!
language
	^ language! !

!ITSession methodsFor: 'accessing' stamp: 'mt 12/26/2007 11:36'!
language: anObject
	language := anObject! !

!ITSession methodsFor: 'accessing' stamp: 'mig 12/30/2007 15:49'!
securityManager
	^ securityManager ifNil: [ securityManager := ITSecurityManager new ].
! !

!ITSession methodsFor: 'accessing' stamp: 'mt 1/5/2008 11:57'!
user
	"Returns the current user object or the default user if nobody is logged in. NIL is never returned."
	
	user isNil ifTrue: [self user: 
		(ITGlorpSession getInstance readOneOf: ITUser where: [:each|each username = '*DEFAULT'])].
	^user! !

!ITSession methodsFor: 'accessing' stamp: 'mig 12/10/2007 17:46'!
user: anObject
	user := anObject! !

!ByteString methodsFor: '*SWE-IssueTracker' stamp: 'mt 12/26/2007 11:42'!
tr
	"Uses ITTranslator for translating this string into another language."	
		
	|lang|
	[lang := WACurrentSession language]
		on: MessageNotUnderstood "for testing purpose only"
		do: [lang := #default].
		
	^ITTranslator getInstance translate: self into: lang.! !

Error subclass: #ITError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITError commentStamp: 'mt 12/30/2007 14:39' prior: 0!
I am an generic error which should only be signaled in this application.!

ITError subclass: #ITUnauthorizedError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITUnauthorizedError commentStamp: 'mig 12/22/2007 16:58' prior: 0!
An ITUnauthorizedError is thrown, when a user has not sufficient privileges to perform an action.!
